/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.41.0-dev.20230713(580db0532140847311413204b6963fcadeb7f55a)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(O){for(var n=[],M=0,D=O.length;M<D;M++)n[M]=J[O[M]];return n};const Ee=this,Re=typeof global=="object"?global:{};var ue;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ue||(ue={}));var ue;(function(O){class n{constructor(l,d,w){this.type=l,this.detail=d,this.timestamp=w}}O.LoaderEvent=n;class M{constructor(l){this._events=[new n(1,"",l)]}record(l,d){this._events.push(new n(l,d,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=M;class D{record(l,d){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(ue||(ue={}));var ue;(function(O){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let l;for(l in D)D.hasOwnProperty(l)&&i(l,D[l])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(l,d)=>{d&&typeof d=="object"?i[l]=n.recursiveClone(d):i[l]=d}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(i){if(i instanceof Error)return i;const l=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(l.stack=i.stack),l}O.ensureError=n;class M{static validateConfigurationOptions(l){function d(w){if(w.phase==="loading"){console.error('Loading "'+w.moduleId+'" failed'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}if(w.phase==="factory"){console.error('The factory function of "'+w.moduleId+'" has thrown an exception'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError>"u"&&(l.catchError=!1),typeof l.recordStats>"u"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=d),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(O.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags>"u"&&(l.preferScriptTags=!1),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){const w=n(new Error("INVALID cached data configuration, 'path' MUST be set"));w.phase="configuration",l.onError(w),l.nodeCachedData=void 0}return l}static mergeConfigurationOptions(l=null,d=null){let w=O.Utilities.recursiveClone(d||{});return O.Utilities.forEachProperty(l,(a,s)=>{a==="ignoreDuplicateModules"&&typeof w.ignoreDuplicateModules<"u"?w.ignoreDuplicateModules=w.ignoreDuplicateModules.concat(s):a==="paths"&&typeof w.paths<"u"?O.Utilities.forEachProperty(s,(m,e)=>w.paths[m]=e):a==="config"&&typeof w.config<"u"?O.Utilities.forEachProperty(s,(m,e)=>w.config[m]=e):w[a]=O.Utilities.recursiveClone(s)}),M.validateConfigurationOptions(w)}}O.ConfigurationOptionsUtil=M;class D{constructor(l,d){if(this._env=l,this.options=M.mergeConfigurationOptions(d),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let w=this.options.nodeRequire.main.filename,a=Math.max(w.lastIndexOf("/"),w.lastIndexOf("\\"));this.options.baseUrl=w.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(l,d)=>{Array.isArray(d)?this.sortedPathsRules.push({from:l,to:d}):this.sortedPathsRules.push({from:l,to:[d]})}),this.sortedPathsRules.sort((l,d)=>d.from.length-l.from.length)}cloneAndMerge(l){return new D(this._env,M.mergeConfigurationOptions(l,this.options))}getOptionsLiteral(){return this.options}_applyPaths(l){let d;for(let w=0,a=this.sortedPathsRules.length;w<a;w++)if(d=this.sortedPathsRules[w],O.Utilities.startsWith(l,d.from)){let s=[];for(let m=0,e=d.to.length;m<e;m++)s.push(d.to[m]+l.substr(d.from.length));return s}return[l]}_addUrlArgsToUrl(l){return O.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l}_addUrlArgsIfNecessaryToUrls(l){if(this.options.urlArgs)for(let d=0,w=l.length;d<w;d++)l[d]=this._addUrlArgsToUrl(l[d]);return l}moduleIdToPaths(l){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l))return this.isBuild()?["empty:"]:["node|"+l];let d=l,w;if(!O.Utilities.endsWith(d,".js")&&!O.Utilities.isAbsolutePath(d)){w=this._applyPaths(d);for(let a=0,s=w.length;a<s;a++)this.isBuild()&&w[a]==="empty:"||(O.Utilities.isAbsolutePath(w[a])||(w[a]=this.options.baseUrl+w[a]),!O.Utilities.endsWith(w[a],".js")&&!O.Utilities.containsQueryString(w[a])&&(w[a]=w[a]+".js"))}else!O.Utilities.endsWith(d,".js")&&!O.Utilities.containsQueryString(d)&&(d=d+".js"),w=[d];return this._addUrlArgsIfNecessaryToUrls(w)}requireToUrl(l){let d=l;return O.Utilities.isAbsolutePath(d)||(d=this._applyPaths(d)[0],O.Utilities.isAbsolutePath(d)||(d=this.options.baseUrl+d)),this._addUrlArgsIfNecessaryToUrl(d)}isBuild(){return this.options.isBuild}shouldInvokeFactory(l){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(l)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[l])}isDuplicateMessageIgnoredFor(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)}getConfigForModule(l){if(this.options.config)return this.options.config[l]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(l){this.options.onError(l)}}O.Configuration=D})(ue||(ue={}));var ue;(function(O){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,m,e,c){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:g}=s.getConfig().getOptionsLiteral();g?this._scriptLoader=new M:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new M;let f={callback:e,errorback:c};if(this._callbackMap.hasOwnProperty(m)){this._callbackMap[m].push(f);return}this._callbackMap[m]=[f],this._scriptLoader.load(s,m,()=>this.triggerCallback(m),g=>this.triggerErrorback(m,g))}triggerCallback(s){let m=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<m.length;e++)m[e].callback()}triggerErrorback(s,m){let e=this._callbackMap[s];delete this._callbackMap[s];for(let c=0;c<e.length;c++)e[c].errorback(m)}}class M{attachListeners(s,m,e){let c=()=>{s.removeEventListener("load",f),s.removeEventListener("error",g)},f=_=>{c(),m()},g=_=>{c(),e(_)};s.addEventListener("load",f),s.addEventListener("error",g)}load(s,m,e,c){if(/^node\|/.test(m)){let f=s.getConfig().getOptionsLiteral(),g=d(s.getRecorder(),f.nodeRequire||O.global.nodeRequire),_=m.split("|"),b=null;try{b=g(_[1])}catch(N){c(N);return}s.enqueueDefineAnonymousModule([],()=>b),e()}else{let f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript"),this.attachListeners(f,e,c);const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();g&&(m=g.createScriptURL(m)),f.setAttribute("src",m);const{cspNonce:_}=s.getConfig().getOptionsLiteral();_&&f.setAttribute("nonce",_),document.getElementsByTagName("head")[0].appendChild(f)}}}function D(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,m,e,c){if(/^node\|/.test(m)){const f=s.getConfig().getOptionsLiteral(),g=d(s.getRecorder(),f.nodeRequire||O.global.nodeRequire),_=m.split("|");let b=null;try{b=g(_[1])}catch(N){c(N);return}s.enqueueDefineAnonymousModule([],function(){return b}),e()}else{const{trustedTypesPolicy:f}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(m).then(_=>{if(_.status!==200)throw new Error(_.statusText);return _.text()}).then(_=>{_=`${_}
//# sourceURL=${m}`,(f?self.eval(f.createScript("",_)):new Function(_)).call(self),e()}).then(void 0,c);return}try{f&&(m=f.createScriptURL(m)),importScripts(m),e()}catch(_){c(_)}}}}class l{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,m){const{nodeCachedData:e}=m.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const c=this,f=s("module");function g(_){const b=_.constructor;let N=function(A){try{return _.require(A)}finally{}};return N.resolve=function(A,S){return b._resolveFilename(A,_,!1,S)},N.resolve.paths=function(A){return b._resolveLookupPaths(A,_)},N.main=process.mainModule,N.extensions=b._extensions,N.cache=b._cache,N}f.prototype._compile=function(_,b){const N=f.wrap(_.replace(/^#!.*/,"")),p=m.getRecorder(),A=c._getCachedDataPath(e,b),S={filename:b};let h;try{const E=c._fs.readFileSync(A);h=E.slice(0,16),S.cachedData=E.slice(16),p.record(60,A)}catch{p.record(61,A)}const r=new c._vm.Script(N,S),o=r.runInThisContext(S),u=c._path.dirname(b),L=g(this),C=[this.exports,L,this,b,u,process,Re,Buffer],v=o.apply(this.exports,C);return c._handleCachedData(r,N,A,!S.cachedData,m),c._verifyCachedData(r,N,A,h,m),v}}load(s,m,e,c){const f=s.getConfig().getOptionsLiteral(),g=d(s.getRecorder(),f.nodeRequire||O.global.nodeRequire),_=f.nodeInstrumenter||function(N){return N};this._init(g),this._initNodeRequire(g,s);let b=s.getRecorder();if(/^node\|/.test(m)){let N=m.split("|"),p=null;try{p=g(N[1])}catch(A){c(A);return}s.enqueueDefineAnonymousModule([],()=>p),e()}else{m=O.Utilities.fileUriToFilePath(this._env.isWindows,m);const N=this._path.normalize(m),p=this._getElectronRendererScriptPathOrUri(N),A=!!f.nodeCachedData,S=A?this._getCachedDataPath(f.nodeCachedData,m):void 0;this._readSourceAndCachedData(N,S,b,(h,r,o,u)=>{if(h){c(h);return}let L;r.charCodeAt(0)===l._BOM?L=l._PREFIX+r.substring(1)+l._SUFFIX:L=l._PREFIX+r+l._SUFFIX,L=_(L,N);const C={filename:p,cachedData:o},v=this._createAndEvalScript(s,L,C,e,c);this._handleCachedData(v,L,S,A&&!o,s),this._verifyCachedData(v,L,S,u,s)})}}_createAndEvalScript(s,m,e,c,f){const g=s.getRecorder();g.record(31,e.filename);const _=new this._vm.Script(m,e),b=_.runInThisContext(e),N=s.getGlobalAMDDefineFunc();let p=!1;const A=function(){return p=!0,N.apply(null,arguments)};return A.amd=N.amd,b.call(O.global,s.getGlobalAMDRequireFunc(),A,e.filename,this._path.dirname(e.filename)),g.record(32,e.filename),p?c():f(new Error(`Didn't receive define call in ${e.filename}!`)),_}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let m=s.match(/^([a-z])\:(.*)/i);return m?`file:///${(m[1].toUpperCase()+":"+m[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,m){const e=this._crypto.createHash("md5").update(m,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),c=this._path.basename(m).replace(/\.js$/,"");return this._path.join(s.path,`${c}-${e}.code`)}_handleCachedData(s,m,e,c,f){s.cachedDataRejected?this._fs.unlink(e,g=>{f.getRecorder().record(62,e),this._createAndWriteCachedData(s,m,e,f),g&&f.getConfig().onError(g)}):c&&this._createAndWriteCachedData(s,m,e,f)}_createAndWriteCachedData(s,m,e,c){let f=Math.ceil(c.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),g=-1,_=0,b;const N=()=>{setTimeout(()=>{b||(b=this._crypto.createHash("md5").update(m,"utf8").digest());const p=s.createCachedData();if(!(p.length===0||p.length===g||_>=5)){if(p.length<g){N();return}g=p.length,this._fs.writeFile(e,Buffer.concat([b,p]),A=>{A&&c.getConfig().onError(A),c.getRecorder().record(63,e),N()})}},f*Math.pow(4,_++))};N()}_readSourceAndCachedData(s,m,e,c){if(!m)this._fs.readFile(s,{encoding:"utf8"},c);else{let f,g,_,b=2;const N=p=>{p?c(p):--b===0&&c(void 0,f,g,_)};this._fs.readFile(s,{encoding:"utf8"},(p,A)=>{f=A,N(p)}),this._fs.readFile(m,(p,A)=>{!p&&A&&A.length>0?(_=A.slice(0,16),g=A.slice(16),e.record(60,m)):e.record(61,m),N()})}}_verifyCachedData(s,m,e,c,f){c&&(s.cachedDataRejected||setTimeout(()=>{const g=this._crypto.createHash("md5").update(m,"utf8").digest();c.equals(g)||(f.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,_=>{_&&f.getConfig().onError(_)}))},Math.ceil(5e3*(1+Math.random()))))}}l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`;function d(a,s){if(s.__$__isRecorded)return s;const m=function(c){a.record(33,c);try{return s(c)}finally{a.record(34,c)}};return m.__$__isRecorded=!0,m}O.ensureRecordedNodeRequire=d;function w(a){return new n(a)}O.createScriptLoader=w})(ue||(ue={}));var ue;(function(O){class n{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,m;for(m=/\/\.\//;m.test(s);)s=s.replace(m,"/");for(s=s.replace(/^\.\//g,""),m=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;m.test(s);)s=s.replace(m,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),O.ModuleIdResolver=n;class M{constructor(a,s,m,e,c,f){this.id=a,this.strId=s,this.dependencies=m,this._callback=e,this._errorback=c,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(O.global,s),producedError:null}}catch(m){return{returnedValue:null,producedError:m}}}static _invokeFactory(a,s,m,e){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(m,e):{returnedValue:m.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,m,e){this._isComplete=!0;let c=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let f=M._invokeFactory(s,this.strId,this._callback,m);c=f.producedError,a.record(22,this.strId),!c&&typeof f.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=f.returnedValue)}else this.exports=this._callback;if(c){let f=O.ensureError(c);f.phase="factory",f.moduleId=this.strId,f.neededBy=e(this.id),this.error=f,s.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=M;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class l{constructor(a,s,m){this.id=a,this.pluginId=s,this.pluginParam=m}}O.PluginDependency=l;class d{constructor(a,s,m,e,c=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=c,this._defineFunc=m,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let m=f=>f.replace(/\\/g,"/"),e=m(a),c=s.split(/\n/);for(let f=0;f<c.length;f++){let g=c[f].match(/(.*):(\d+):(\d+)\)?$/);if(g){let _=g[1],b=g[2],N=g[3],p=Math.max(_.lastIndexOf(" ")+1,_.lastIndexOf("(")+1);if(_=_.substr(p),_=m(_),_===e){let A={line:parseInt(b,10),col:parseInt(N,10)};return A.line===1&&(A.col-=53),A}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let m=0,e=this._modules2.length;m<e;m++){let c=this._modules2[m];if(!c)continue;let f=this._buildInfoPath[c.id]||null,g=this._buildInfoDefineStack[c.id]||null,_=this._buildInfoDependencies[c.id];a[s++]={id:c.strId,path:f,defineLocation:f&&g?d._findRelevantLocationInStack(f,g):null,dependencies:_,shim:null,exports:c.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let m=null;this._config.isBuild()&&(m=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:m,dependencies:a,callback:s}}defineModule(a,s,m,e,c,f=new n(a)){let g=this._moduleIdProvider.getModuleId(a);if(this._modules2[g]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let _=new M(g,a,this._normalizeDependencies(s,f),m,e,f);this._modules2[g]=_,this._config.isBuild()&&(this._buildInfoDefineStack[g]=c,this._buildInfoDependencies[g]=(_.dependencies||[]).map(b=>this._moduleIdProvider.getStrModuleId(b.id))),this._resolve(_)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let m=a.indexOf("!");if(m>=0){let e=s.resolveModule(a.substr(0,m)),c=s.resolveModule(a.substr(m+1)),f=this._moduleIdProvider.getModuleId(e+"!"+c),g=this._moduleIdProvider.getModuleId(e);return new l(f,g,c)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let m=[],e=0;for(let c=0,f=a.length;c<f;c++)m[e++]=this._normalizeDependency(a[c],s);return m}_relativeRequire(a,s,m,e){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(O.Utilities.generateAnonymousModule(),s,m,e,null,a)}synchronousRequire(a,s=new n(a)){let m=this._normalizeDependency(a,s),e=this._modules2[m.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(a,s){let m=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!m&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let m=this._moduleIdProvider.getStrModuleId(a),e=(this._inverseDependencies2[a]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));const c=O.ensureError(s);return c.phase="loading",c.moduleId=m,c.neededBy=e,c}_onLoadError(a,s){const m=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new M(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let e=[];for(let g=0,_=this._moduleIdProvider.getMaxModuleId();g<_;g++)e[g]=!1;let c=!1,f=[];for(f.push(a),e[a]=!0;f.length>0;){let g=f.shift(),_=this._modules2[g];_&&(c=_.onDependencyError(m)||c);let b=this._inverseDependencies2[g];if(b)for(let N=0,p=b.length;N<p;N++){let A=b[N];e[A]||(f.push(A),e[A]=!0)}}c||this._config.onError(m)}_hasDependencyPath(a,s){let m=this._modules2[a];if(!m)return!1;let e=[];for(let f=0,g=this._moduleIdProvider.getMaxModuleId();f<g;f++)e[f]=!1;let c=[];for(c.push(m),e[a]=!0;c.length>0;){let g=c.shift().dependencies;if(g)for(let _=0,b=g.length;_<b;_++){let N=g[_];if(N.id===s)return!0;let p=this._modules2[N.id];p&&!e[N.id]&&(e[N.id]=!0,c.push(p))}}return!1}_findCyclePath(a,s,m){if(a===s||m===50)return[a];let e=this._modules2[a];if(!e)return null;let c=e.dependencies;if(c)for(let f=0,g=c.length;f<g;f++){let _=this._findCyclePath(c[f].id,s,m+1);if(_!==null)return _.push(a),_}return null}_createRequire(a){let s=(m,e,c)=>this._relativeRequire(a,m,e,c);return s.toUrl=m=>this._config.requireToUrl(a.resolveModule(m)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(m,e=!1)=>{this.configure(m,e)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),m=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&m.push("node|"+s);let c=-1,f=g=>{if(c++,c>=m.length)this._onLoadError(a,g);else{let _=m[c],b=this.getRecorder();if(this._config.isBuild()&&_==="empty:"){this._buildInfoPath[a]=_,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}b.record(10,_),this._scriptLoader.load(this,_,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=_),b.record(11,_),this._onLoad(a)},N=>{b.record(12,_),f(N)})}};f(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let m=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};m.error=e=>{this._config.onError(this._createLoadError(s.id,e))},a.load(s.pluginParam,this._createRequire(n.ROOT),m,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let m=0,e=s.length;m<e;m++){let c=s[m];if(c===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(c===i.MODULE){a.unresolvedDependenciesCount--;continue}if(c===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let f=this._modules2[c.id];if(f&&f.isComplete()){if(f.error){a.onDependencyError(f.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let g=this._findCyclePath(c.id,a.id,0)||[];g.reverse(),g.push(c.id),console.warn(g.map(_=>this._moduleIdProvider.getStrModuleId(_)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(a.id),c instanceof l){let g=this._modules2[c.pluginId];if(g&&g.isComplete()){this._loadPluginDependency(g.exports,c);continue}let _=this._inversePluginDependencies2.get(c.pluginId);_||(_=[],this._inversePluginDependencies2.set(c.pluginId,_)),_.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let m=a.dependencies,e=[];if(m)for(let _=0,b=m.length;_<b;_++){let N=m[_];if(N===i.EXPORTS){e[_]=a.exports;continue}if(N===i.MODULE){e[_]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===i.REQUIRE){e[_]=this._createRequire(a.moduleIdResolver);continue}let p=this._modules2[N.id];if(p){e[_]=p.exports;continue}e[_]=null}const c=_=>(this._inverseDependencies2[_]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));a.complete(s,this._config,e,c);let f=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,f)for(let _=0,b=f.length;_<b;_++){let N=f[_],p=this._modules2[N];p.unresolvedDependenciesCount--,p.unresolvedDependenciesCount===0&&this._onModuleComplete(p)}let g=this._inversePluginDependencies2.get(a.id);if(g){this._inversePluginDependencies2.delete(a.id);for(let _=0,b=g.length;_<b;_++)this._loadPluginDependency(a.exports,g[_])}}}O.ModuleManager=d})(ue||(ue={}));var X,ue;(function(O){const n=new O.Environment;let M=null;const D=function(w,a,s){typeof w!="string"&&(s=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),w?M.defineModule(w,a,s,null,null):M.enqueueDefineAnonymousModule(a,s)};D.amd={jQuery:!0};const i=function(w,a=!1){M.configure(w,a)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=i,l.getConfig=function(){return M.getConfig().getOptionsLiteral()},l.reset=function(){M=M.reset()},l.getBuildInfo=function(){return M.getBuildInfo()},l.getStats=function(){return M.getLoaderEvents()},l.define=D;function d(){if(typeof O.global.require<"u"||typeof require<"u"){const w=O.global.require||require;if(typeof w=="function"&&typeof w.resolve=="function"){const a=O.ensureRecordedNodeRequire(M.getRecorder(),w);O.global.nodeRequire=a,l.nodeRequire=a,l.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=l:(n.isElectronRenderer||(O.global.define=D),O.global.require=l)}O.init=d,(typeof O.global.define!="function"||!O.global.define.amd)&&(M=new O.ModuleManager(n,O.createScriptLoader(n),D,l,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&l.config(O.global.require),X=function(){return D.apply(null,arguments)},X.amd=D.amd,typeof doNotInitLoader>"u"&&d())})(ue||(ue={}));var ge=this&&this.__awaiter||function(O,n,M,D){function i(l){return l instanceof M?l:new M(function(d){d(l)})}return new(M||(M=Promise))(function(l,d){function w(m){try{s(D.next(m))}catch(e){d(e)}}function a(m){try{s(D.throw(m))}catch(e){d(e)}}function s(m){m.done?l(m.value):i(m.value).then(w,a)}s((D=D.apply(O,n||[])).next())})};X(J[25],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let M=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(g,_){let b;return _.length===0?b=g:b=g.replace(/\{(\d+)\}/g,(N,p)=>{const A=p[0],S=_[A];let h=N;return typeof S=="string"?h=S:(typeof S=="number"||typeof S=="boolean"||S===void 0||S===null)&&(h=String(S)),h}),M&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function l(g,_){let b=g[_];return b||(b=g["*"],b)?b:null}function d(g){return g.charAt(g.length-1)==="/"?g:g+"/"}function w(g,_,b){return ge(this,void 0,void 0,function*(){const N=d(g)+d(_)+"vscode/"+d(b),p=yield fetch(N);if(p.ok)return yield p.json();throw new Error(`${p.status} - ${p.statusText}`)})}function a(g){return function(_,b){const N=Array.prototype.slice.call(arguments,2);return i(g[_],N)}}function s(g,_,...b){return i(_,b)}n.localize=s;function m(g){}n.getConfiguredDefaultLocale=m;function e(g){M=g}n.setPseudoTranslation=e;function c(g,_){var b;return{localize:a(_[g]),getConfiguredDefaultLocale:(b=_.getConfiguredDefaultLocale)!==null&&b!==void 0?b:N=>{}}}n.create=c;function f(g,_,b,N){var p;const A=(p=N["vs/nls"])!==null&&p!==void 0?p:{};if(!g||g.length===0)return b({localize:s,getConfiguredDefaultLocale:()=>{var u;return(u=A.availableLanguages)===null||u===void 0?void 0:u["*"]}});const S=A.availableLanguages?l(A.availableLanguages,g):null,h=S===null||S===D;let r=".nls";h||(r=r+"."+S);const o=u=>{Array.isArray(u)?u.localize=a(u):u.localize=a(u[g]),u.getConfiguredDefaultLocale=()=>{var L;return(L=A.availableLanguages)===null||L===void 0?void 0:L["*"]},b(u)};typeof A.loadBundle=="function"?A.loadBundle(g,S,(u,L)=>{u?_([g+".nls"],o):o(L)}):A.translationServiceUrl&&!h?ge(this,void 0,void 0,function*(){var u;try{const L=yield w(A.translationServiceUrl,S,g);return o(L)}catch(L){if(!S.includes("-"))return console.error(L),_([g+".nls"],o);try{const C=S.split("-")[0],v=yield w(A.translationServiceUrl,C,g);return(u=A.availableLanguages)!==null&&u!==void 0||(A.availableLanguages={}),A.availableLanguages["*"]=C,o(v)}catch(C){return console.error(C),_([g+".nls"],o)}}}):_([g+r],o,u=>{if(r===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${S}. Falling back to the default language:`,u),_([g+".nls"],o)})}n.load=f}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function M(m,e){var c;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(m,e)}catch(f){console.warn(f);return}try{return(c=self.trustedTypes)===null||c===void 0?void 0:c.createPolicy(m,e)}catch(f){console.warn(f);return}}const D=M("amdLoader",{createScriptURL:m=>m,createScript:(m,...e)=>{const c=e.slice(0,-1).join(","),f=e.pop().toString();return`(function anonymous(${c}) { ${f}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function l(){return new Promise((m,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return m();const c=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(c).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${c}`,(D?globalThis.eval(D.createScript("",g)):new Function(g)).call(globalThis),m()}).then(void 0,e);return}D?importScripts(D.createScriptURL(c)):importScripts(c),m()})}function d(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function w(m){l().then(()=>{d(),require([m],function(e){setTimeout(function(){const c=e.create((f,g)=>{globalThis.postMessage(f,g)},null);for(globalThis.onmessage=f=>c.onmessage(f.data,f.ports);s.length>0;){const f=s.shift();c.onmessage(f.data,f.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&d();let a=!0;const s=[];globalThis.onmessage=m=>{if(!a){s.push(m);return}a=!1,w(m.data)}}(),X(J[26],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function M(I,x=0){return I[I.length-(1+x)]}n.tail=M;function D(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=D;function i(I,x,q=(z,t)=>z===t){if(I===x)return!0;if(!I||!x||I.length!==x.length)return!1;for(let z=0,t=I.length;z<t;z++)if(!q(I[z],x[z]))return!1;return!0}n.equals=i;function l(I,x){const q=I.length-1;x<q&&(I[x]=I[q]),I.pop()}n.removeFastWithoutKeepingOrder=l;function d(I,x,q){return w(I.length,z=>q(I[z],x))}n.binarySearch=d;function w(I,x){let q=0,z=I-1;for(;q<=z;){const t=(q+z)/2|0,ne=x(t);if(ne<0)q=t+1;else if(ne>0)z=t-1;else return t}return-(q+1)}n.binarySearch2=w;function a(I,x){let q=0,z=I.length;if(z===0)return 0;for(;q<z;){const t=Math.floor((q+z)/2);x(I[t])?z=t:q=t+1}return q}n.findFirstInSorted=a;function s(I,x,q){if(I=I|0,I>=x.length)throw new TypeError("invalid index");const z=x[Math.floor(x.length*Math.random())],t=[],ne=[],ie=[];for(const he of x){const me=q(he,z);me<0?t.push(he):me>0?ne.push(he):ie.push(he)}return I<t.length?s(I,t,q):I<t.length+ie.length?ie[0]:s(I-(t.length+ie.length),ne,q)}n.quickSelect=s;function m(I,x){const q=[];let z;for(const t of I.slice(0).sort(x))!z||x(z[0],t)!==0?(z=[t],q.push(z)):z.push(t);return q}n.groupBy=m;function e(I){return I.filter(x=>!!x)}n.coalesce=e;function c(I){let x=0;for(let q=0;q<I.length;q++)I[q]&&(I[x]=I[q],x+=1);I.length=x}n.coalesceInPlace=c;function f(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=f;function g(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=g;function _(I,x=q=>q){const q=new Set;return I.filter(z=>{const t=x(z);return q.has(t)?!1:(q.add(t),!0)})}n.distinct=_;function b(I,x){const q=N(I,x);if(q!==-1)return I[q]}n.findLast=b;function N(I,x){for(let q=I.length-1;q>=0;q--){const z=I[q];if(x(z))return q}return-1}n.lastIndex=N;function p(I,x){return I.length>0?I[0]:x}n.firstOrDefault=p;function A(I,x){let q=typeof x=="number"?I:0;typeof x=="number"?q=I:(q=0,x=I);const z=[];if(q<=x)for(let t=q;t<x;t++)z.push(t);else for(let t=q;t>x;t--)z.push(t);return z}n.range=A;function S(I,x,q){const z=I.slice(0,x),t=I.slice(x);return z.concat(q,t)}n.arrayInsert=S;function h(I,x){const q=I.indexOf(x);q>-1&&(I.splice(q,1),I.unshift(x))}n.pushToStart=h;function r(I,x){const q=I.indexOf(x);q>-1&&(I.splice(q,1),I.push(x))}n.pushToEnd=r;function o(I,x){for(const q of x)I.push(q)}n.pushMany=o;function u(I){return Array.isArray(I)?I:[I]}n.asArray=u;function L(I,x){for(const q of I){const z=x(q);if(z!==void 0)return z}}n.mapFind=L;function C(I,x,q){const z=E(I,x),t=I.length,ne=q.length;I.length=t+ne;for(let ie=t-1;ie>=z;ie--)I[ie+ne]=I[ie];for(let ie=0;ie<ne;ie++)I[ie+z]=q[ie]}n.insertInto=C;function v(I,x,q,z){const t=E(I,x),ne=I.splice(t,q);return C(I,t,z),ne}n.splice=v;function E(I,x){return x<0?Math.max(x+I.length,0):Math.min(x,I.length)}var y;(function(I){function x(t){return t<0}I.isLessThan=x;function q(t){return t>0}I.isGreaterThan=q;function z(t){return t===0}I.isNeitherLessOrGreaterThan=z,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(y||(n.CompareResult=y={}));function R(I,x){return(q,z)=>x(I(q),I(z))}n.compareBy=R;const F=(I,x)=>I-x;n.numberComparator=F;function T(I,x){if(I.length===0)return;let q=I[0];for(let z=1;z<I.length;z++){const t=I[z];x(t,q)>0&&(q=t)}return q}n.findMaxBy=T;function P(I,x){if(I.length===0)return;let q=I[0];for(let z=1;z<I.length;z++){const t=I[z];x(t,q)>=0&&(q=t)}return q}n.findLastMaxBy=P;function U(I,x){return T(I,(q,z)=>-x(q,z))}n.findMinBy=U;class W{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let q=this.firstIdx;for(;q<this.items.length&&x(this.items[q]);)q++;const z=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,z}takeFromEndWhile(x){let q=this.lastIdx;for(;q>=0&&x(this.items[q]);)q--;const z=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}takeCount(x){const q=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,q}}n.ArrayQueue=W;class H{constructor(x){this.iterate=x}toArray(){const x=[];return this.iterate(q=>(x.push(q),!0)),x}filter(x){return new H(q=>this.iterate(z=>x(z)?q(z):!0))}map(x){return new H(q=>this.iterate(z=>q(x(z))))}findLast(x){let q;return this.iterate(z=>(x(z)&&(q=z),!0)),q}findLastMaxBy(x){let q,z=!0;return this.iterate(t=>((z||y.isGreaterThan(x(t,q)))&&(z=!1,q=t),!0)),q}}n.CallbackIterable=H,H.empty=new H(I=>{})}),X(J[27],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class M{constructor(l){this.fn=l,this.lastCache=void 0,this.lastArgKey=void 0}get(l){const d=JSON.stringify(l);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(l)),this.lastCache}}n.LRUCachedFunction=M;class D{get cachedValues(){return this._map}constructor(l){this.fn=l,this._map=new Map}get(l){if(this._map.has(l))return this._map.get(l);const d=this.fn(l);return this._map.set(l,d),d}}n.CachedFunction=D}),X(J[28],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function M(w,a){const s=Math.pow(10,a);return Math.round(w*s)/s}class D{constructor(a,s,m,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=M(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}n.RGBA=D;class i{constructor(a,s,m,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=M(Math.max(Math.min(1,s),0),3),this.l=M(Math.max(Math.min(1,m),0),3),this.a=M(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,m=a.g/255,e=a.b/255,c=a.a,f=Math.max(s,m,e),g=Math.min(s,m,e);let _=0,b=0;const N=(g+f)/2,p=f-g;if(p>0){switch(b=Math.min(N<=.5?p/(2*N):p/(2-2*N),1),f){case s:_=(m-e)/p+(m<e?6:0);break;case m:_=(e-s)/p+2;break;case e:_=(s-m)/p+4;break}_*=60,_=Math.round(_)}return new i(_,b,N,c)}static _hue2rgb(a,s,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?a+(s-a)*6*m:m<1/2?s:m<2/3?a+(s-a)*(2/3-m)*6:a}static toRGBA(a){const s=a.h/360,{s:m,l:e,a:c}=a;let f,g,_;if(m===0)f=g=_=e;else{const b=e<.5?e*(1+m):e+m-e*m,N=2*e-b;f=i._hue2rgb(N,b,s+1/3),g=i._hue2rgb(N,b,s),_=i._hue2rgb(N,b,s-1/3)}return new D(Math.round(f*255),Math.round(g*255),Math.round(_*255),c)}}n.HSLA=i;class l{constructor(a,s,m,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=M(Math.max(Math.min(1,s),0),3),this.v=M(Math.max(Math.min(1,m),0),3),this.a=M(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,m=a.g/255,e=a.b/255,c=Math.max(s,m,e),f=Math.min(s,m,e),g=c-f,_=c===0?0:g/c;let b;return g===0?b=0:c===s?b=((m-e)/g%6+6)%6:c===m?b=(e-s)/g+2:b=(s-m)/g+4,new l(Math.round(b*60),_,c,a.a)}static toRGBA(a){const{h:s,s:m,v:e,a:c}=a,f=e*m,g=f*(1-Math.abs(s/60%2-1)),_=e-f;let[b,N,p]=[0,0,0];return s<60?(b=f,N=g):s<120?(b=g,N=f):s<180?(N=f,p=g):s<240?(N=g,p=f):s<300?(b=g,p=f):s<=360&&(b=f,p=g),b=Math.round((b+_)*255),N=Math.round((N+_)*255),p=Math.round((p+_)*255),new D(b,N,p,c)}}n.HSVA=l;class d{static fromHex(a){return d.Format.CSS.parseHex(a)||d.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:l.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof D)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof l)this._hsva=a,this.rgba=l.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&D.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&l.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=d._relativeLuminanceForComponent(this.rgba.r),s=d._relativeLuminanceForComponent(this.rgba.g),m=d._relativeLuminanceForComponent(this.rgba.b),e=.2126*a+.7152*s+.0722*m;return M(e,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),m=a.getRelativeLuminance();return s>m}isDarkerThan(a){const s=this.getRelativeLuminance(),m=a.getRelativeLuminance();return s<m}lighten(a){return new d(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new d(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:m,b:e,a:c}=this.rgba;return new d(new D(s,m,e,c*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:m,b:e,a:c}=this.rgba;return new d(new D(a.rgba.r-c*(a.rgba.r-s),a.rgba.g-c*(a.rgba.g-m),a.rgba.b-c*(a.rgba.b-e),1))}toString(){return this._toString||(this._toString=d.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,m){if(a.isLighterThan(s))return a;m=m||.5;const e=a.getRelativeLuminance(),c=s.getRelativeLuminance();return m=m*(c-e)/c,a.lighten(m)}static getDarkerColor(a,s,m){if(a.isDarkerThan(s))return a;m=m||.5;const e=a.getRelativeLuminance(),c=s.getRelativeLuminance();return m=m*(e-c)/e,a.darken(m)}}n.Color=d,d.white=new d(new D(255,255,255,1)),d.black=new d(new D(0,0,0,1)),d.red=new d(new D(255,0,0,1)),d.blue=new d(new D(0,0,255,1)),d.green=new d(new D(0,255,0,1)),d.cyan=new d(new D(0,255,255,1)),d.lightgrey=new d(new D(211,211,211,1)),d.transparent=new d(new D(0,0,0,0)),function(w){let a;(function(s){let m;(function(e){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:w.Format.CSS.formatRGBA(r)}e.formatRGB=c;function f(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=f;function g(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(r)}e.formatHSL=g;function _(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=_;function b(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function N(r){return`#${b(r.rgba.r)}${b(r.rgba.g)}${b(r.rgba.b)}`}e.formatHex=N;function p(r,o=!1){return o&&r.rgba.a===1?w.Format.CSS.formatHex(r):`#${b(r.rgba.r)}${b(r.rgba.g)}${b(r.rgba.b)}${b(Math.round(r.rgba.a*255))}`}e.formatHexA=p;function A(r){return r.isOpaque()?w.Format.CSS.formatHex(r):w.Format.CSS.formatRGBA(r)}e.format=A;function S(r){const o=r.length;if(o===0||r.charCodeAt(0)!==35)return null;if(o===7){const u=16*h(r.charCodeAt(1))+h(r.charCodeAt(2)),L=16*h(r.charCodeAt(3))+h(r.charCodeAt(4)),C=16*h(r.charCodeAt(5))+h(r.charCodeAt(6));return new w(new D(u,L,C,1))}if(o===9){const u=16*h(r.charCodeAt(1))+h(r.charCodeAt(2)),L=16*h(r.charCodeAt(3))+h(r.charCodeAt(4)),C=16*h(r.charCodeAt(5))+h(r.charCodeAt(6)),v=16*h(r.charCodeAt(7))+h(r.charCodeAt(8));return new w(new D(u,L,C,v/255))}if(o===4){const u=h(r.charCodeAt(1)),L=h(r.charCodeAt(2)),C=h(r.charCodeAt(3));return new w(new D(16*u+u,16*L+L,16*C+C))}if(o===5){const u=h(r.charCodeAt(1)),L=h(r.charCodeAt(2)),C=h(r.charCodeAt(3)),v=h(r.charCodeAt(4));return new w(new D(16*u+u,16*L+L,16*C+C,(16*v+v)/255))}return null}e.parseHex=S;function h(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=s.CSS||(s.CSS={}))})(a=w.Format||(w.Format={}))}(d||(n.Color=d={}))}),X(J[29],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(i,l,d,w){this.originalStart=i,this.originalLength=l,this.modifiedStart=d,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),X(J[4],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(b){setTimeout(()=>{throw b.stack?f.isErrorNoTelemetry(b)?new f(b.message+`

`+b.stack):new Error(b.message+`

`+b.stack):b},0)}}emit(b){this.listeners.forEach(N=>{N(b)})}onUnexpectedError(b){this.unexpectedErrorHandler(b),this.emit(b)}onUnexpectedExternalError(b){this.unexpectedErrorHandler(b)}}n.ErrorHandler=M,n.errorHandler=new M;function D(_){w(_)||n.errorHandler.onUnexpectedError(_)}n.onUnexpectedError=D;function i(_){w(_)||n.errorHandler.onUnexpectedExternalError(_)}n.onUnexpectedExternalError=i;function l(_){if(_ instanceof Error){const{name:b,message:N}=_,p=_.stacktrace||_.stack;return{$isError:!0,name:b,message:N,stack:p,noTelemetry:f.isErrorNoTelemetry(_)}}return _}n.transformErrorForSerialization=l;const d="Canceled";function w(_){return _ instanceof a?!0:_ instanceof Error&&_.name===d&&_.message===d}n.isCancellationError=w;class a extends Error{constructor(){super(d),this.name=this.message}}n.CancellationError=a;function s(){const _=new Error(d);return _.name=_.message,_}n.canceled=s;function m(_){return _?new Error(`Illegal argument: ${_}`):new Error("Illegal argument")}n.illegalArgument=m;function e(_){return _?new Error(`Illegal state: ${_}`):new Error("Illegal state")}n.illegalState=e;class c extends Error{constructor(b){super("NotSupported"),b&&(this.message=b)}}n.NotSupportedError=c;class f extends Error{constructor(b){super(b),this.name="CodeExpectedError"}static fromError(b){if(b instanceof f)return b;const N=new f;return N.message=b.message,N.stack=b.stack,N}static isErrorNoTelemetry(b){return b.name==="CodeExpectedError"}}n.ErrorNoTelemetry=f;class g extends Error{constructor(b){super(b||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}n.BugIndicatingError=g}),X(J[9],Z([0,1,4]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(w,a){if(!w)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}n.ok=D;function i(w,a="Unreachable"){throw new Error(a)}n.assertNever=i;function l(w){if(!w()){debugger;w(),(0,M.onUnexpectedError)(new M.BugIndicatingError("Assertion Failed"))}}n.assertFn=l;function d(w,a){let s=0;for(;s<w.length-1;){const m=w[s],e=w[s+1];if(!a(m,e))return!1;s++}return!0}n.checkAdjacentItems=d}),X(J[15],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(D){const i=this;let l=!1,d;return function(){return l||(l=!0,d=D.apply(i,arguments)),d}}n.once=M}),X(J[16],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(D){function i(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}D.is=i;const l=Object.freeze([]);function d(){return l}D.empty=d;function*w(S){yield S}D.single=w;function a(S){return i(S)?S:w(S)}D.wrap=a;function s(S){return S||l}D.from=s;function m(S){return!S||S[Symbol.iterator]().next().done===!0}D.isEmpty=m;function e(S){return S[Symbol.iterator]().next().value}D.first=e;function c(S,h){for(const r of S)if(h(r))return!0;return!1}D.some=c;function f(S,h){for(const r of S)if(h(r))return r}D.find=f;function*g(S,h){for(const r of S)h(r)&&(yield r)}D.filter=g;function*_(S,h){let r=0;for(const o of S)yield h(o,r++)}D.map=_;function*b(...S){for(const h of S)for(const r of h)yield r}D.concat=b;function N(S,h,r){let o=r;for(const u of S)o=h(o,u);return o}D.reduce=N;function*p(S,h,r=S.length){for(h<0&&(h+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);h<r;h++)yield S[h]}D.slice=p;function A(S,h=Number.POSITIVE_INFINITY){const r=[];if(h===0)return[r,S];const o=S[Symbol.iterator]();for(let u=0;u<h;u++){const L=o.next();if(L.done)return[r,D.empty()];r.push(L.value)}return[r,{[Symbol.iterator](){return o}}]}D.consume=A})(M||(n.Iterable=M={}))}),X(J[30],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,f){this._keyCodeToStr[c]=f,this._strToKeyCode[f.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const D=new M,i=new M,l=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],w=Object.create(null),a=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",c=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],f=[],g=[];for(const _ of c){const[b,N,p,A,S,h,r,o,u]=_;if(g[N]||(g[N]=!0,d[N]=p,w[p]=N,a[p.toLowerCase()]=N,b&&(n.IMMUTABLE_CODE_TO_KEY_CODE[N]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[A]=N))),!f[A]){if(f[A]=!0,!S)throw new Error(`String representation missing for key code ${A} around scan code ${p}`);D.define(A,S),i.define(A,o||S),l.define(A,u||o||S)}h&&(n.EVENT_KEY_CODE_MAP[h]=A),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=A)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function c(p){return D.keyCodeToStr(p)}e.toString=c;function f(p){return D.strToKeyCode(p)}e.fromString=f;function g(p){return i.keyCodeToStr(p)}e.toUserSettingsUS=g;function _(p){return l.keyCodeToStr(p)}e.toUserSettingsGeneral=_;function b(p){return i.strToKeyCode(p)||l.strToKeyCode(p)}e.fromUserSettings=b;function N(p){if(p>=98&&p<=113)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(p)}e.toElectronAccelerator=N})(s||(n.KeyCodeUtils=s={}));function m(e,c){const f=(c&65535)<<16>>>0;return(e|f)>>>0}n.KeyChord=m}),X(J[31],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class M{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=M}),X(J[10],Z([0,1,15,16]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let l=null;function d(r){l=r}if(n.setDisposableTracker=d,i){const r="__is_disposable_tracked__";d(new class{trackDisposable(o){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(u)},3e3)}setParent(o,u){if(o&&o!==N.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==N.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function w(r){return l?.trackDisposable(r),r}function a(r){l?.markAsDisposed(r)}function s(r,o){l?.setParent(r,o)}function m(r,o){if(l)for(const u of r)l.setParent(u,o)}function e(r){return l?.markAsSingleton(r),r}n.markAsSingleton=e;function c(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=c;function f(r){if(D.Iterable.is(r)){const o=[];for(const u of r)if(u)try{u.dispose()}catch(L){o.push(L)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=f;function g(...r){const o=_(()=>f(r));return m(r,o),o}n.combinedDisposable=g;function _(r){const o=w({dispose:(0,M.once)(()=>{a(o),r()})});return o}n.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return s(o,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}n.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new b,w(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}n.Disposable=N,N.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var u;this._isDisposed||o===this._value||((u=this._value)===null||u===void 0||u.dispose(),o&&s(o,this),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,a(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}n.MutableDisposable=p;class A{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=A;class S{constructor(o){this.object=o}dispose(){}}n.ImmortalReference=S;class h{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{f(this._store.values())}finally{this._store.clear()}}get(o){return this._store.get(o)}set(o,u,L=!1){var C;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(C=this._store.get(o))===null||C===void 0||C.dispose(),this._store.set(o,u)}deleteAndDispose(o){var u;(u=this._store.get(o))===null||u===void 0||u.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=h}),X(J[17],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(l){this.element=l,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class D{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let l=this._first;for(;l!==M.Undefined;){const d=l.next;l.prev=M.Undefined,l.next=M.Undefined,l=d}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,d){const w=new M(l);if(this._first===M.Undefined)this._first=w,this._last=w;else if(d){const s=this._last;this._last=w,w.prev=s,s.next=w}else{const s=this._first;this._first=w,w.next=s,s.prev=w}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(w))}}shift(){if(this._first!==M.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==M.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==M.Undefined&&l.next!==M.Undefined){const d=l.prev;d.next=l.next,l.next.prev=d}else l.prev===M.Undefined&&l.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):l.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):l.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==M.Undefined;)yield l.element,l=l.next}}n.LinkedList=D}),X(J[18],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const M=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(l){return new D(l)}constructor(l){this._now=M&&l===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=D}),X(J[7],Z([0,1,4,15,10,17,18]),function(O,n,M,D,i,l,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const w=!1,a=!1;var s;(function(C){C.None=()=>i.Disposable.None;function v(Q){if(a){const{onDidAddListener:$}=Q,Y=f.create();let j=0;Q.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function E(Q,$){return I(Q,()=>{},0,void 0,!0,void 0,$)}C.defer=E;function y(Q){return($,Y=null,j)=>{let K=!1,te;return te=Q(re=>{if(!K)return te?te.dispose():K=!0,$.call(Y,re)},null,j),K&&te.dispose(),te}}C.once=y;function R(Q,$,Y){return H((j,K=null,te)=>Q(re=>j.call(K,$(re)),null,te),Y)}C.map=R;function F(Q,$,Y){return H((j,K=null,te)=>Q(re=>{$(re),j.call(K,re)},null,te),Y)}C.forEach=F;function T(Q,$,Y){return H((j,K=null,te)=>Q(re=>$(re)&&j.call(K,re),null,te),Y)}C.filter=T;function P(Q){return Q}C.signal=P;function U(...Q){return($,Y=null,j)=>(0,i.combinedDisposable)(...Q.map(K=>K(te=>$.call(Y,te),null,j)))}C.any=U;function W(Q,$,Y,j){let K=Y;return R(Q,te=>(K=$(K,te),K),j)}C.reduce=W;function H(Q,$){let Y;const j={onWillAddFirstListener(){Y=Q(K.fire,K)},onDidRemoveLastListener(){Y?.dispose()}};$||v(j);const K=new N(j);return $?.add(K),K.event}function I(Q,$,Y=100,j=!1,K=!1,te,re){let fe,ce,_e,k=0,B;const V={leakWarningThreshold:te,onWillAddFirstListener(){fe=Q(ee=>{k++,ce=$(ce,ee),j&&!_e&&(G.fire(ce),ce=void 0),B=()=>{const le=ce;ce=void 0,_e=void 0,(!j||k>1)&&G.fire(le),k=0},typeof Y=="number"?(clearTimeout(_e),_e=setTimeout(B,Y)):_e===void 0&&(_e=0,queueMicrotask(B))})},onWillRemoveListener(){K&&k>0&&B?.()},onDidRemoveLastListener(){B=void 0,fe.dispose()}};re||v(V);const G=new N(V);return re?.add(G),G.event}C.debounce=I;function x(Q,$=0,Y){return C.debounce(Q,(j,K)=>j?(j.push(K),j):[K],$,void 0,!0,void 0,Y)}C.accumulate=x;function q(Q,$=(j,K)=>j===K,Y){let j=!0,K;return T(Q,te=>{const re=j||!$(te,K);return j=!1,K=te,re},Y)}C.latch=q;function z(Q,$,Y){return[C.filter(Q,$,Y),C.filter(Q,j=>!$(j),Y)]}C.split=z;function t(Q,$=!1,Y=[]){let j=Y.slice(),K=Q(fe=>{j?j.push(fe):re.fire(fe)});const te=()=>{j?.forEach(fe=>re.fire(fe)),j=null},re=new N({onWillAddFirstListener(){K||(K=Q(fe=>re.fire(fe)))},onDidAddFirstListener(){j&&($?setTimeout(te):te())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return re.event}C.buffer=t;class ne{constructor($){this.event=$,this.disposables=new i.DisposableStore}map($){return new ne(R(this.event,$,this.disposables))}forEach($){return new ne(F(this.event,$,this.disposables))}filter($){return new ne(T(this.event,$,this.disposables))}reduce($,Y){return new ne(W(this.event,$,Y,this.disposables))}latch(){return new ne(q(this.event,void 0,this.disposables))}debounce($,Y=100,j=!1,K=!1,te){return new ne(I(this.event,$,Y,j,K,te,this.disposables))}on($,Y,j){return this.event($,Y,j)}once($,Y,j){return y(this.event)($,Y,j)}dispose(){this.disposables.dispose()}}function ie(Q){return new ne(Q)}C.chain=ie;function he(Q,$,Y=j=>j){const j=(...fe)=>re.fire(Y(...fe)),K=()=>Q.on($,j),te=()=>Q.removeListener($,j),re=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return re.event}C.fromNodeEventEmitter=he;function me(Q,$,Y=j=>j){const j=(...fe)=>re.fire(Y(...fe)),K=()=>Q.addEventListener($,j),te=()=>Q.removeEventListener($,j),re=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return re.event}C.fromDOMEventEmitter=me;function be(Q){return new Promise($=>y(Q)($))}C.toPromise=be;function pe(Q,$){return $(void 0),Q(Y=>$(Y))}C.runAndSubscribe=pe;function Le(Q,$){let Y=null;function j(te){Y?.dispose(),Y=new i.DisposableStore,$(te,Y)}j(void 0);const K=Q(te=>j(te));return(0,i.toDisposable)(()=>{K.dispose(),Y?.dispose()})}C.runAndSubscribeWithStore=Le;class Ce{constructor($,Y){this._observable=$,this._counter=0,this._hasChanged=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||v(j),this.emitter=new N(j),Y&&Y.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,Y){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function se(Q,$){return new Ce(Q,$).emitter.event}C.fromObservable=se;function ae(Q){return $=>{let Y=0,j=!1;const K={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Q.reportChanges(),j&&(j=!1,$()))},handlePossibleChange(){},handleChange(){j=!0}};return Q.addObserver(K),{dispose(){Q.removeObserver(K)}}}}C.fromObservableLight=ae})(s||(n.Event=s={}));class m{constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${m._idPool++}`,m.all.add(this)}start(v){this._stopWatch=new d.StopWatch,this.listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=m,m.all=new Set,m._idPool=0;let e=-1;class c{constructor(v,E=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=E,this._warnCountdown=0}dispose(){var v;(v=this._stacks)===null||v===void 0||v.clear()}check(v,E){const y=this.threshold;if(y<=0||E<y)return;this._stacks||(this._stacks=new Map);const R=this._stacks.get(v.value)||0;if(this._stacks.set(v.value,R+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let F,T=0;for(const[P,U]of this._stacks)(!F||T<U)&&(F=P,T=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${T}):`),console.warn(F)}return()=>{const F=this._stacks.get(v.value)||0;this._stacks.set(v.value,F-1)}}}class f{static create(){var v;return new f((v=new Error().stack)!==null&&v!==void 0?v:"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(v){this.value=v}}const _=2,b=(C,v)=>{if(C instanceof g)v(C);else for(let E=0;E<C.length;E++){const y=C[E];y&&v(y)}};class N{constructor(v){var E,y,R,F,T;this._size=0,this._options=v,this._leakageMon=e>0||!((E=this._options)===null||E===void 0)&&E.leakWarningThreshold?new c((R=(y=this._options)===null||y===void 0?void 0:y.leakWarningThreshold)!==null&&R!==void 0?R:e):void 0,this._perfMon=!((F=this._options)===null||F===void 0)&&F._profName?new m(this._options._profName):void 0,this._deliveryQueue=(T=this._options)===null||T===void 0?void 0:T.deliveryQueue}dispose(){var v,E,y,R;if(!this._disposed){if(this._disposed=!0,((v=this._deliveryQueue)===null||v===void 0?void 0:v.current)===this&&this._deliveryQueue.reset(),this._listeners){if(w){const F=this._listeners;queueMicrotask(()=>{b(F,T=>{var P;return(P=T.stack)===null||P===void 0?void 0:P.print()})})}this._listeners=void 0,this._size=0}(y=(E=this._options)===null||E===void 0?void 0:E.onDidRemoveLastListener)===null||y===void 0||y.call(E),(R=this._leakageMon)===null||R===void 0||R.dispose()}}get event(){var v;return(v=this._event)!==null&&v!==void 0||(this._event=(E,y,R)=>{var F,T,P,U,W;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;y&&(E=E.bind(y));const H=new g(E);let I,x;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(H.stack=f.create(),I=this._leakageMon.check(H.stack,this._size+1)),w&&(H.stack=x??f.create()),this._listeners?this._listeners instanceof g?((W=this._deliveryQueue)!==null&&W!==void 0||(this._deliveryQueue=new A),this._listeners=[this._listeners,H]):this._listeners.push(H):((T=(F=this._options)===null||F===void 0?void 0:F.onWillAddFirstListener)===null||T===void 0||T.call(F,this),this._listeners=H,(U=(P=this._options)===null||P===void 0?void 0:P.onDidAddFirstListener)===null||U===void 0||U.call(P,this)),this._size++;const q=(0,i.toDisposable)(()=>{I?.(),this._removeListener(H)});return R instanceof i.DisposableStore?R.add(q):Array.isArray(R)&&R.push(q),q}),this._event}_removeListener(v){var E,y,R,F;if((y=(E=this._options)===null||E===void 0?void 0:E.onWillRemoveListener)===null||y===void 0||y.call(E,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(F=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||F===void 0||F.call(R,this),this._size=0;return}const T=this._listeners,P=T.indexOf(v);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,T[P]=void 0;const U=this._deliveryQueue.current===this;if(this._size*_<=T.length){let W=0;for(let H=0;H<T.length;H++)T[H]?T[W++]=T[H]:U&&(this._deliveryQueue.end--,W<this._deliveryQueue.i&&this._deliveryQueue.i--);T.length=W}}_deliver(v,E){var y;if(!v)return;const R=((y=this._options)===null||y===void 0?void 0:y.onListenerError)||M.onUnexpectedError;if(!R){v.value(E);return}try{v.value(E)}catch(F){R(F)}}_deliverQueue(v){const E=v.current._listeners;for(;v.i<v.end;)this._deliver(E[v.i++],v.value);v.reset()}fire(v){var E,y,R,F;if(!((E=this._deliveryQueue)===null||E===void 0)&&E.current&&(this._deliverQueue(this._deliveryQueue),(y=this._perfMon)===null||y===void 0||y.stop()),(R=this._perfMon)===null||R===void 0||R.start(this._size),this._listeners)if(this._listeners instanceof g)this._deliver(this._listeners,v);else{const T=this._deliveryQueue;T.enqueue(this,v,this._listeners.length),this._deliverQueue(T)}(F=this._perfMon)===null||F===void 0||F.stop()}hasListeners(){return this._size>0}}n.Emitter=N;const p=()=>new A;n.createEventDeliveryQueue=p;class A{constructor(){this.i=-1,this.end=0}enqueue(v,E,y){this.i=0,this.end=y,this.current=v,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends N{constructor(v){super(v),this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._size&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}n.PauseableEmitter=S;class h extends S{constructor(v){var E;super(v),this._delay=(E=v.delay)!==null&&E!==void 0?E:100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}n.DebounceEmitter=h;class r extends N{constructor(v){super(v),this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this.hasListeners()&&(this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const E={event:v,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const y=()=>{this.hasListeners&&this.unhook(E);const R=this.events.indexOf(E);this.events.splice(R,1)};return(0,i.toDisposable)((0,D.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(E=>this.emitter.fire(E))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=o;class u{constructor(){this.buffers=[]}wrapEvent(v){return(E,y,R)=>v(F=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>E.call(y,F)):E.call(y,F)},void 0,R)}bufferEvents(v){const E=[];this.buffers.push(E);const y=v();return this.buffers.pop(),E.forEach(R=>R()),y}}n.EventBufferer=u;class L{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new N({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=L}),X(J[32],Z([0,1,7]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(w,a){const s=setTimeout(w.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(w){function a(s){return s===w.None||s===w.Cancelled||s instanceof l?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}w.isCancellationToken=a,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(n.CancellationToken=i={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class d{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){var s;a&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=d}),X(J[5],Z([0,1,27,31]),function(O,n,M,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function l(k){return!k||typeof k!="string"?!0:k.trim().length===0}n.isFalsyOrWhitespace=l;const d=/{(\d+)}/g;function w(k,...B){return B.length===0?k:k.replace(d,function(V,G){const ee=parseInt(G,10);return isNaN(ee)||ee<0||ee>=B.length?V:B[ee]})}n.format=w;function a(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=a;function s(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function m(k,B=" "){const V=e(k,B);return c(V,B)}n.trim=m;function e(k,B){if(!k||!B)return k;const V=B.length;if(V===0||k.length===0)return k;let G=0;for(;k.indexOf(B,G)===G;)G=G+V;return k.substring(G)}n.ltrim=e;function c(k,B){if(!k||!B)return k;const V=B.length,G=k.length;if(V===0||G===0)return k;let ee=G,le=-1;for(;le=k.lastIndexOf(B,ee-1),!(le===-1||le+V!==ee);){if(le===0)return"";ee=le}return k.substring(0,ee)}n.rtrim=c;function f(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=f;function g(k){return k.replace(/\*/g,"")}n.stripWildcards=g;function _(k,B,V={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=s(k)),V.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let G="";return V.global&&(G+="g"),V.matchCase||(G+="i"),V.multiline&&(G+="m"),V.unicode&&(G+="u"),new RegExp(k,G)}n.createRegExp=_;function b(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}n.regExpLeadsToEndlessLoop=b;function N(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}n.regExpFlags=N;function p(k){return k.split(/\r\n|\r|\n/)}n.splitLines=p;function A(k){for(let B=0,V=k.length;B<V;B++){const G=k.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}n.firstNonWhitespaceIndex=A;function S(k,B=0,V=k.length){for(let G=B;G<V;G++){const ee=k.charCodeAt(G);if(ee!==32&&ee!==9)return k.substring(B,G)}return k.substring(B,V)}n.getLeadingWhitespace=S;function h(k,B=k.length-1){for(let V=B;V>=0;V--){const G=k.charCodeAt(V);if(G!==32&&G!==9)return V}return-1}n.lastNonWhitespaceIndex=h;function r(k,B){return k<B?-1:k>B?1:0}n.compare=r;function o(k,B,V=0,G=k.length,ee=0,le=B.length){for(;V<G&&ee<le;V++,ee++){const we=k.charCodeAt(V),oe=B.charCodeAt(ee);if(we<oe)return-1;if(we>oe)return 1}const de=G-V,ye=le-ee;return de<ye?-1:de>ye?1:0}n.compareSubstring=o;function u(k,B){return L(k,B,0,k.length,0,B.length)}n.compareIgnoreCase=u;function L(k,B,V=0,G=k.length,ee=0,le=B.length){for(;V<G&&ee<le;V++,ee++){let we=k.charCodeAt(V),oe=B.charCodeAt(ee);if(we===oe)continue;if(we>=128||oe>=128)return o(k.toLowerCase(),B.toLowerCase(),V,G,ee,le);v(we)&&(we-=32),v(oe)&&(oe-=32);const ve=we-oe;if(ve!==0)return ve}const de=G-V,ye=le-ee;return de<ye?-1:de>ye?1:0}n.compareSubstringIgnoreCase=L;function C(k){return k>=48&&k<=57}n.isAsciiDigit=C;function v(k){return k>=97&&k<=122}n.isLowerAsciiLetter=v;function E(k){return k>=65&&k<=90}n.isUpperAsciiLetter=E;function y(k,B){return k.length===B.length&&L(k,B)===0}n.equalsIgnoreCase=y;function R(k,B){const V=B.length;return B.length>k.length?!1:L(k,B,0,V)===0}n.startsWithIgnoreCase=R;function F(k,B){const V=Math.min(k.length,B.length);let G;for(G=0;G<V;G++)if(k.charCodeAt(G)!==B.charCodeAt(G))return G;return V}n.commonPrefixLength=F;function T(k,B){const V=Math.min(k.length,B.length);let G;const ee=k.length-1,le=B.length-1;for(G=0;G<V;G++)if(k.charCodeAt(ee-G)!==B.charCodeAt(le-G))return G;return V}n.commonSuffixLength=T;function P(k){return 55296<=k&&k<=56319}n.isHighSurrogate=P;function U(k){return 56320<=k&&k<=57343}n.isLowSurrogate=U;function W(k,B){return(k-55296<<10)+(B-56320)+65536}n.computeCodePoint=W;function H(k,B,V){const G=k.charCodeAt(V);if(P(G)&&V+1<B){const ee=k.charCodeAt(V+1);if(U(ee))return W(G,ee)}return G}n.getNextCodePoint=H;function I(k,B){const V=k.charCodeAt(B-1);if(U(V)&&B>1){const G=k.charCodeAt(B-2);if(P(G))return W(G,V)}return V}class x{get offset(){return this._offset}constructor(B,V=0){this._str=B,this._len=B.length,this._offset=V}setOffset(B){this._offset=B}prevCodePoint(){const B=I(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=H(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=x;class q{get offset(){return this._iterator.offset}constructor(B,V=0){this._iterator=new x(B,V)}nextGraphemeLength(){const B=j.getInstance(),V=this._iterator,G=V.offset;let ee=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const le=V.offset,de=B.getGraphemeBreakType(V.nextCodePoint());if(Y(ee,de)){V.setOffset(le);break}ee=de}return V.offset-G}prevGraphemeLength(){const B=j.getInstance(),V=this._iterator,G=V.offset;let ee=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const le=V.offset,de=B.getGraphemeBreakType(V.prevCodePoint());if(Y(de,ee)){V.setOffset(le);break}ee=de}return G-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=q;function z(k,B){return new q(k,B).nextGraphemeLength()}n.nextCharLength=z;function t(k,B){return new q(k,B).prevGraphemeLength()}n.prevCharLength=t;function ne(k,B){B>0&&U(k.charCodeAt(B))&&B--;const V=B+z(k,B);return[V-t(k,V),V]}n.getCharContainingOffset=ne;let ie;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function me(k){return ie||(ie=he()),ie.test(k)}n.containsRTL=me;const be=/^[\t\n\r\x20-\x7E]*$/;function pe(k){return be.test(k)}n.isBasicASCII=pe,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(k){return n.UNUSUAL_LINE_TERMINATORS.test(k)}n.containsUnusualLineTerminators=Le;function Ce(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}n.isFullWidthCharacter=Ce;function se(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}n.isEmojiImprecise=se,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function Q(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}n.containsUppercaseCharacter=Q;function $(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}n.singleLetterHash=$;function Y(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}class j{static getInstance(){return j._INSTANCE||(j._INSTANCE=new j),j._INSTANCE}constructor(){this._data=K()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this._data,G=V.length/3;let ee=1;for(;ee<=G;)if(B<V[3*ee])ee=2*ee;else if(B>V[3*ee+1])ee=2*ee+1;else return V[3*ee+2];return 0}}j._INSTANCE=null;function K(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function te(k,B){if(k===0)return 0;const V=re(k,B);if(V!==void 0)return V;const G=new x(B,k);return G.prevCodePoint(),G.offset}n.getLeftDeleteOffset=te;function re(k,B){const V=new x(B,k);let G=V.prevCodePoint();for(;fe(G)||G===65039||G===8419;){if(V.offset===0)return;G=V.prevCodePoint()}if(!se(G))return;let ee=V.offset;return ee>0&&V.prevCodePoint()===8205&&(ee=V.offset),ee}function fe(k){return 127995<=k&&k<=127999}n.noBreakWhitespace="\xA0";class ce{static getInstance(B){return ce.cache.get(Array.from(B))}static getLocales(){return ce._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ce,i=ce,ce.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ce.cache=new M.LRUCachedFunction(k=>{function B(oe){const ve=new Map;for(let Se=0;Se<oe.length;Se+=2)ve.set(oe[Se],oe[Se+1]);return ve}function V(oe,ve){const Se=new Map(oe);for(const[Ne,Ae]of ve)Se.set(Ne,Ae);return Se}function G(oe,ve){if(!oe)return ve;const Se=new Map;for(const[Ne,Ae]of oe)ve.has(Ne)&&Se.set(Ne,Ae);return Se}const ee=i.ambiguousCharacterData.value;let le=k.filter(oe=>!oe.startsWith("_")&&oe in ee);le.length===0&&(le=["_default"]);let de;for(const oe of le){const ve=B(ee[oe]);de=G(de,ve)}const ye=B(ee._common),we=V(ye,de);return new ce(we)}),ce._locales=new D.Lazy(()=>Object.keys(ce.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(B){return _e.getData().has(B)}static get codePoints(){return _e.getData()}}n.InvisibleCharacters=_e,_e._data=void 0}),X(J[33],Z([0,1,5]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(_){return i(_,0)}n.hash=D;function i(_,b){switch(typeof _){case"object":return _===null?l(349,b):Array.isArray(_)?a(_,b):s(_,b);case"string":return w(_,b);case"boolean":return d(_,b);case"number":return l(_,b);case"undefined":return l(937,b);default:return l(617,b)}}n.doHash=i;function l(_,b){return(b<<5)-b+_|0}n.numberHash=l;function d(_,b){return l(_?433:863,b)}function w(_,b){b=l(149417,b);for(let N=0,p=_.length;N<p;N++)b=l(_.charCodeAt(N),b);return b}n.stringHash=w;function a(_,b){return b=l(104579,b),_.reduce((N,p)=>i(p,N),b)}function s(_,b){return b=l(181387,b),Object.keys(_).sort().reduce((N,p)=>(N=w(p,N),i(_[p],N)),b)}function m(_,b,N=32){const p=N-b,A=~((1<<p)-1);return(_<<b|(A&_)>>>p)>>>0}function e(_,b=0,N=_.byteLength,p=0){for(let A=0;A<N;A++)_[b+A]=p}function c(_,b,N="0"){for(;_.length<b;)_=N+_;return _}function f(_,b=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(N=>N.toString(16).padStart(2,"0")).join(""):c((_>>>0).toString(16),b/4)}n.toHexString=f;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const N=b.length;if(N===0)return;const p=this._buff;let A=this._buffLen,S=this._leftoverHighSurrogate,h,r;for(S!==0?(h=S,r=-1,S=0):(h=b.charCodeAt(0),r=0);;){let o=h;if(M.isHighSurrogate(h))if(r+1<N){const u=b.charCodeAt(r+1);M.isLowSurrogate(u)?(r++,o=M.computeCodePoint(h,u)):o=65533}else{S=h;break}else M.isLowSurrogate(h)&&(o=65533);if(A=this._push(p,A,o),r++,r<N)h=b.charCodeAt(r);else break}this._buffLen=A,this._leftoverHighSurrogate=S}_push(b,N,p){return p<128?b[N++]=p:p<2048?(b[N++]=192|(p&1984)>>>6,b[N++]=128|(p&63)>>>0):p<65536?(b[N++]=224|(p&61440)>>>12,b[N++]=128|(p&4032)>>>6,b[N++]=128|(p&63)>>>0):(b[N++]=240|(p&1835008)>>>18,b[N++]=128|(p&258048)>>>12,b[N++]=128|(p&4032)>>>6,b[N++]=128|(p&63)>>>0),N>=64&&(this._step(),N-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),N}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=g._bigBlock32,N=this._buffDV;for(let C=0;C<64;C+=4)b.setUint32(C,N.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)b.setUint32(C,m(b.getUint32(C-12,!1)^b.getUint32(C-32,!1)^b.getUint32(C-56,!1)^b.getUint32(C-64,!1),1),!1);let p=this._h0,A=this._h1,S=this._h2,h=this._h3,r=this._h4,o,u,L;for(let C=0;C<80;C++)C<20?(o=A&S|~A&h,u=1518500249):C<40?(o=A^S^h,u=1859775393):C<60?(o=A&S|A&h|S&h,u=2400959708):(o=A^S^h,u=3395469782),L=m(p,5)+o+r+u+b.getUint32(C*4,!1)&4294967295,r=h,h=S,S=m(A,30),A=p,p=L;this._h0=this._h0+p&4294967295,this._h1=this._h1+A&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),X(J[19],Z([0,1,29,33]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,c=new Int32Array(e.length);for(let f=0,g=e.length;f<g;f++)c[f]=e.charCodeAt(f);return c}}n.StringDiffSequence=i;function l(m,e,c){return new s(new i(m),new i(e)).ComputeDiff(c).changes}n.stringDiff=l;class d{static Assert(e,c){if(!e)throw new Error(c)}}class w{static Copy(e,c,f,g,_){for(let b=0;b<_;b++)f[g+b]=e[c+b]}static Copy2(e,c,f,g,_){for(let b=0;b<_;b++)f[g+b]=e[c+b]}}class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(e,c){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,c,f=null){this.ContinueProcessingPredicate=f,this._originalSequence=e,this._modifiedSequence=c;const[g,_,b]=s._getElements(e),[N,p,A]=s._getElements(c);this._hasStrings=b&&A,this._originalStringElements=g,this._originalElementsOrHash=_,this._modifiedStringElements=N,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const c=e.getElements();if(s._isStringArray(c)){const f=new Int32Array(c.length);for(let g=0,_=c.length;g<_;g++)f[g]=(0,D.stringHash)(c[g],0);return[c,f,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(e,c){if(!this.ElementsAreEqual(e,c))return!1;const f=s._getStrictElement(this._originalSequence,e),g=s._getStrictElement(this._modifiedSequence,c);return f===g}static _getStrictElement(e,c){return typeof e.getStrictElement=="function"?e.getStrictElement(c):null}OriginalElementsAreEqual(e,c){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(e,c){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[c]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,c,f,g,_){const b=[!1];let N=this.ComputeDiffRecursive(e,c,f,g,b);return _&&(N=this.PrettifyChanges(N)),{quitEarly:b[0],changes:N}}ComputeDiffRecursive(e,c,f,g,_){for(_[0]=!1;e<=c&&f<=g&&this.ElementsAreEqual(e,f);)e++,f++;for(;c>=e&&g>=f&&this.ElementsAreEqual(c,g);)c--,g--;if(e>c||f>g){let h;return f<=g?(d.Assert(e===c+1,"originalStart should only be one more than originalEnd"),h=[new M.DiffChange(e,0,f,g-f+1)]):e<=c?(d.Assert(f===g+1,"modifiedStart should only be one more than modifiedEnd"),h=[new M.DiffChange(e,c-e+1,f,0)]):(d.Assert(e===c+1,"originalStart should only be one more than originalEnd"),d.Assert(f===g+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const b=[0],N=[0],p=this.ComputeRecursionPoint(e,c,f,g,b,N,_),A=b[0],S=N[0];if(p!==null)return p;if(!_[0]){const h=this.ComputeDiffRecursive(e,A,f,S,_);let r=[];return _[0]?r=[new M.DiffChange(A+1,c-(A+1)+1,S+1,g-(S+1)+1)]:r=this.ComputeDiffRecursive(A+1,c,S+1,g,_),this.ConcatenateChanges(h,r)}return[new M.DiffChange(e,c-e+1,f,g-f+1)]}WALKTRACE(e,c,f,g,_,b,N,p,A,S,h,r,o,u,L,C,v,E){let y=null,R=null,F=new a,T=c,P=f,U=o[0]-C[0]-g,W=-1073741824,H=this.m_forwardHistory.length-1;do{const I=U+e;I===T||I<P&&A[I-1]<A[I+1]?(h=A[I+1],u=h-U-g,h<W&&F.MarkNextChange(),W=h,F.AddModifiedElement(h+1,u),U=I+1-e):(h=A[I-1]+1,u=h-U-g,h<W&&F.MarkNextChange(),W=h-1,F.AddOriginalElement(h,u+1),U=I-1-e),H>=0&&(A=this.m_forwardHistory[H],e=A[0],T=1,P=A.length-1)}while(--H>=-1);if(y=F.getReverseChanges(),E[0]){let I=o[0]+1,x=C[0]+1;if(y!==null&&y.length>0){const q=y[y.length-1];I=Math.max(I,q.getOriginalEnd()),x=Math.max(x,q.getModifiedEnd())}R=[new M.DiffChange(I,r-I+1,x,L-x+1)]}else{F=new a,T=b,P=N,U=o[0]-C[0]-p,W=1073741824,H=v?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const I=U+_;I===T||I<P&&S[I-1]>=S[I+1]?(h=S[I+1]-1,u=h-U-p,h>W&&F.MarkNextChange(),W=h+1,F.AddOriginalElement(h+1,u+1),U=I+1-_):(h=S[I-1],u=h-U-p,h>W&&F.MarkNextChange(),W=h,F.AddModifiedElement(h+1,u+1),U=I-1-_),H>=0&&(S=this.m_reverseHistory[H],_=S[0],T=1,P=S.length-1)}while(--H>=-1);R=F.getChanges()}return this.ConcatenateChanges(y,R)}ComputeRecursionPoint(e,c,f,g,_,b,N){let p=0,A=0,S=0,h=0,r=0,o=0;e--,f--,_[0]=0,b[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const u=c-e+(g-f),L=u+1,C=new Int32Array(L),v=new Int32Array(L),E=g-f,y=c-e,R=e-f,F=c-g,P=(y-E)%2===0;C[E]=e,v[y]=c,N[0]=!1;for(let U=1;U<=u/2+1;U++){let W=0,H=0;S=this.ClipDiagonalBound(E-U,U,E,L),h=this.ClipDiagonalBound(E+U,U,E,L);for(let x=S;x<=h;x+=2){x===S||x<h&&C[x-1]<C[x+1]?p=C[x+1]:p=C[x-1]+1,A=p-(x-E)-R;const q=p;for(;p<c&&A<g&&this.ElementsAreEqual(p+1,A+1);)p++,A++;if(C[x]=p,p+A>W+H&&(W=p,H=A),!P&&Math.abs(x-y)<=U-1&&p>=v[x])return _[0]=p,b[0]=A,q<=v[x]&&1447>0&&U<=1447+1?this.WALKTRACE(E,S,h,R,y,r,o,F,C,v,p,c,_,A,g,b,P,N):null}const I=(W-e+(H-f)-U)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(W,I))return N[0]=!0,_[0]=W,b[0]=H,I>0&&1447>0&&U<=1447+1?this.WALKTRACE(E,S,h,R,y,r,o,F,C,v,p,c,_,A,g,b,P,N):(e++,f++,[new M.DiffChange(e,c-e+1,f,g-f+1)]);r=this.ClipDiagonalBound(y-U,U,y,L),o=this.ClipDiagonalBound(y+U,U,y,L);for(let x=r;x<=o;x+=2){x===r||x<o&&v[x-1]>=v[x+1]?p=v[x+1]-1:p=v[x-1],A=p-(x-y)-F;const q=p;for(;p>e&&A>f&&this.ElementsAreEqual(p,A);)p--,A--;if(v[x]=p,P&&Math.abs(x-E)<=U&&p<=C[x])return _[0]=p,b[0]=A,q>=C[x]&&1447>0&&U<=1447+1?this.WALKTRACE(E,S,h,R,y,r,o,F,C,v,p,c,_,A,g,b,P,N):null}if(U<=1447){let x=new Int32Array(h-S+2);x[0]=E-S+1,w.Copy2(C,S,x,1,h-S+1),this.m_forwardHistory.push(x),x=new Int32Array(o-r+2),x[0]=y-r+1,w.Copy2(v,r,x,1,o-r+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(E,S,h,R,y,r,o,F,C,v,p,c,_,A,g,b,P,N)}PrettifyChanges(e){for(let c=0;c<e.length;c++){const f=e[c],g=c<e.length-1?e[c+1].originalStart:this._originalElementsOrHash.length,_=c<e.length-1?e[c+1].modifiedStart:this._modifiedElementsOrHash.length,b=f.originalLength>0,N=f.modifiedLength>0;for(;f.originalStart+f.originalLength<g&&f.modifiedStart+f.modifiedLength<_&&(!b||this.OriginalElementsAreEqual(f.originalStart,f.originalStart+f.originalLength))&&(!N||this.ModifiedElementsAreEqual(f.modifiedStart,f.modifiedStart+f.modifiedLength));){const A=this.ElementsAreStrictEqual(f.originalStart,f.modifiedStart);if(this.ElementsAreStrictEqual(f.originalStart+f.originalLength,f.modifiedStart+f.modifiedLength)&&!A)break;f.originalStart++,f.modifiedStart++}const p=[null];if(c<e.length-1&&this.ChangesOverlap(e[c],e[c+1],p)){e[c]=p[0],e.splice(c+1,1),c--;continue}}for(let c=e.length-1;c>=0;c--){const f=e[c];let g=0,_=0;if(c>0){const h=e[c-1];g=h.originalStart+h.originalLength,_=h.modifiedStart+h.modifiedLength}const b=f.originalLength>0,N=f.modifiedLength>0;let p=0,A=this._boundaryScore(f.originalStart,f.originalLength,f.modifiedStart,f.modifiedLength);for(let h=1;;h++){const r=f.originalStart-h,o=f.modifiedStart-h;if(r<g||o<_||b&&!this.OriginalElementsAreEqual(r,r+f.originalLength)||N&&!this.ModifiedElementsAreEqual(o,o+f.modifiedLength))break;const L=(r===g&&o===_?5:0)+this._boundaryScore(r,f.originalLength,o,f.modifiedLength);L>A&&(A=L,p=h)}f.originalStart-=p,f.modifiedStart-=p;const S=[null];if(c>0&&this.ChangesOverlap(e[c-1],e[c],S)){e[c-1]=S[0],e.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,f=e.length;c<f;c++){const g=e[c-1],_=e[c],b=_.originalStart-g.originalStart-g.originalLength,N=g.originalStart,p=_.originalStart+_.originalLength,A=p-N,S=g.modifiedStart,h=_.modifiedStart+_.modifiedLength,r=h-S;if(b<5&&A<20&&r<20){const o=this._findBetterContiguousSequence(N,A,S,r,b);if(o){const[u,L]=o;(u!==g.originalStart+g.originalLength||L!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=u-g.originalStart,g.modifiedLength=L-g.modifiedStart,_.originalStart=u+b,_.modifiedStart=L+b,_.originalLength=p-_.originalStart,_.modifiedLength=h-_.modifiedStart)}}}return e}_findBetterContiguousSequence(e,c,f,g,_){if(c<_||g<_)return null;const b=e+c-_+1,N=f+g-_+1;let p=0,A=0,S=0;for(let h=e;h<b;h++)for(let r=f;r<N;r++){const o=this._contiguousSequenceScore(h,r,_);o>0&&o>p&&(p=o,A=h,S=r)}return p>0?[A,S]:null}_contiguousSequenceScore(e,c,f){let g=0;for(let _=0;_<f;_++){if(!this.ElementsAreEqual(e+_,c+_))return 0;g+=this._originalStringElements[e+_].length}return g}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,c){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(c>0){const f=e+c;if(this._OriginalIsBoundary(f-1)||this._OriginalIsBoundary(f))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,c){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(c>0){const f=e+c;if(this._ModifiedIsBoundary(f-1)||this._ModifiedIsBoundary(f))return!0}return!1}_boundaryScore(e,c,f,g){const _=this._OriginalRegionIsBoundary(e,c)?1:0,b=this._ModifiedRegionIsBoundary(f,g)?1:0;return _+b}ConcatenateChanges(e,c){const f=[];if(e.length===0||c.length===0)return c.length>0?c:e;if(this.ChangesOverlap(e[e.length-1],c[0],f)){const g=new Array(e.length+c.length-1);return w.Copy(e,0,g,0,e.length-1),g[e.length-1]=f[0],w.Copy(c,1,g,e.length,c.length-1),g}else{const g=new Array(e.length+c.length);return w.Copy(e,0,g,0,e.length),w.Copy(c,0,g,e.length,c.length),g}}ChangesOverlap(e,c,f){if(d.Assert(e.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),d.Assert(e.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=c.originalStart||e.modifiedStart+e.modifiedLength>=c.modifiedStart){const g=e.originalStart;let _=e.originalLength;const b=e.modifiedStart;let N=e.modifiedLength;return e.originalStart+e.originalLength>=c.originalStart&&(_=c.originalStart+c.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=c.modifiedStart&&(N=c.modifiedStart+c.modifiedLength-e.modifiedStart),f[0]=new M.DiffChange(g,_,b,N),!0}else return f[0]=null,!1}ClipDiagonalBound(e,c,f,g){if(e>=0&&e<g)return e;const _=f,b=g-f-1,N=c%2===0;if(e<0){const p=_%2===0;return N===p?0:1}else{const p=b%2===0;return N===p?g-1:g-2}}}n.LcsDiff=s}),X(J[20],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function M(p){return typeof p=="string"}n.isString=M;function D(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}n.isObject=D;function i(p){const A=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof A}n.isTypedArray=i;function l(p){return typeof p=="number"&&!isNaN(p)}n.isNumber=l;function d(p){return!!p&&typeof p[Symbol.iterator]=="function"}n.isIterable=d;function w(p){return p===!0||p===!1}n.isBoolean=w;function a(p){return typeof p>"u"}n.isUndefined=a;function s(p){return!m(p)}n.isDefined=s;function m(p){return a(p)||p===null}n.isUndefinedOrNull=m;function e(p,A){if(!p)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}n.assertType=e;function c(p){if(m(p))throw new Error("Assertion Failed: argument is undefined or null");return p}n.assertIsDefined=c;function f(p){return typeof p=="function"}n.isFunction=f;function g(p,A){const S=Math.min(p.length,A.length);for(let h=0;h<S;h++)_(p[h],A[h])}n.validateConstraints=g;function _(p,A){if(M(A)){if(typeof p!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(f(A)){try{if(p instanceof A)return}catch{}if(!m(p)&&p.constructor===A||A.length===1&&A.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=_;function b(p){return p===null?void 0:p}n.withNullAsUndefined=b;function N(p){return typeof p>"u"?null:p}n.withUndefinedAsNull=N}),X(J[34],Z([0,1,20]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(d,w){if((0,M.isString)(w)){const a=D[w];if(a===void 0)throw new Error(`${d} references an unknown codicon: ${w}`);w=a}return D[d]=w,{id:d}}function l(){return D}n.getCodiconFontCharacters=l,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),X(J[11],Z([0,1,20]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const g=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([_,b])=>{g[_]=b&&typeof b=="object"?D(b):b}),g}n.deepClone=D;function i(f){if(!f||typeof f!="object")return f;const g=[f];for(;g.length>0;){const _=g.shift();Object.freeze(_);for(const b in _)if(l.call(_,b)){const N=_[b];typeof N=="object"&&!Object.isFrozen(N)&&!(0,M.isTypedArray)(N)&&g.push(N)}}return f}n.deepFreeze=i;const l=Object.prototype.hasOwnProperty;function d(f,g){return w(f,g,new Set)}n.cloneAndChange=d;function w(f,g,_){if((0,M.isUndefinedOrNull)(f))return f;const b=g(f);if(typeof b<"u")return b;if(Array.isArray(f)){const N=[];for(const p of f)N.push(w(p,g,_));return N}if((0,M.isObject)(f)){if(_.has(f))throw new Error("Cannot clone recursive data-structure");_.add(f);const N={};for(const p in f)l.call(f,p)&&(N[p]=w(f[p],g,_));return _.delete(f),N}return f}function a(f,g,_=!0){return(0,M.isObject)(f)?((0,M.isObject)(g)&&Object.keys(g).forEach(b=>{b in f?_&&((0,M.isObject)(f[b])&&(0,M.isObject)(g[b])?a(f[b],g[b],_):f[b]=g[b]):f[b]=g[b]}),f):g}n.mixin=a;function s(f,g){if(f===g)return!0;if(f==null||g===null||g===void 0||typeof f!=typeof g||typeof f!="object"||Array.isArray(f)!==Array.isArray(g))return!1;let _,b;if(Array.isArray(f)){if(f.length!==g.length)return!1;for(_=0;_<f.length;_++)if(!s(f[_],g[_]))return!1}else{const N=[];for(b in f)N.push(b);N.sort();const p=[];for(b in g)p.push(b);if(p.sort(),!s(N,p))return!1;for(_=0;_<N.length;_++)if(!s(f[N[_]],g[N[_]]))return!1}return!0}n.equals=s;function m(f){let g=[],_=Object.getPrototypeOf(f);for(;Object.prototype!==_;)g=g.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return g}n.getAllPropertyNames=m;function e(f){const g=[];for(const _ of m(f))typeof f[_]=="function"&&g.push(_);return g}n.getAllMethodNames=e;function c(f,g){const _=N=>function(){const p=Array.prototype.slice.call(arguments,0);return g(N,p)},b={};for(const N of f)b[N]=_(N);return b}n.createProxyObject=c}),X(J[21],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function M(i){return i<0?0:i>255?255:i|0}n.toUint8=M;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),X(J[22],Z([0,1,21]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(d){const w=(0,M.toUint8)(d);this._defaultValue=w,this._asciiMap=D._createAsciiMap(w),this._map=new Map}static _createAsciiMap(d){const w=new Uint8Array(256);return w.fill(d),w}set(d,w){const a=(0,M.toUint8)(w);d>=0&&d<256?this._asciiMap[d]=a:this._map.set(d,a)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class i{constructor(){this._actual=new D(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),X(J[6],Z([0,1,4]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=void 0;class D{static addRange(l,d){let w=0;for(;w<d.length&&d[w].endExclusive<l.start;)w++;let a=w;for(;a<d.length&&d[a].start<=l.endExclusive;)a++;if(w===a)d.splice(w,0,l);else{const s=Math.min(l.start,d[w].start),m=Math.max(l.endExclusive,d[a-1].endExclusive);d.splice(w,a-w,new D(s,m))}}static tryCreate(l,d){if(!(l>d))return new D(l,d)}constructor(l,d){if(this.start=l,this.endExclusive=d,l>d)throw new M.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(l){return new D(this.start+l,this.endExclusive+l)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(l){return this.start===l.start&&this.endExclusive===l.endExclusive}containsRange(l){return this.start<=l.start&&l.endExclusive<=this.endExclusive}join(l){return new D(Math.min(this.start,l.start),Math.max(this.endExclusive,l.endExclusive))}intersect(l){const d=Math.max(this.start,l.start),w=Math.min(this.endExclusive,l.endExclusive);if(d<=w)return new D(d,w)}}n.OffsetRange=D}),X(J[3],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(i,l){this.lineNumber=i,this.column=l}with(i=this.lineNumber,l=this.column){return i===this.lineNumber&&l===this.column?this:new M(i,l)}delta(i=0,l=0){return this.with(this.lineNumber+i,this.column+l)}equals(i){return M.equals(this,i)}static equals(i,l){return!i&&!l?!0:!!i&&!!l&&i.lineNumber===l.lineNumber&&i.column===l.column}isBefore(i){return M.isBefore(this,i)}static isBefore(i,l){return i.lineNumber<l.lineNumber?!0:l.lineNumber<i.lineNumber?!1:i.column<l.column}isBeforeOrEqual(i){return M.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,l){return i.lineNumber<l.lineNumber?!0:l.lineNumber<i.lineNumber?!1:i.column<=l.column}static compare(i,l){const d=i.lineNumber|0,w=l.lineNumber|0;if(d===w){const a=i.column|0,s=l.column|0;return a-s}return d-w}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new M(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=M}),X(J[2],Z([0,1,3]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(l,d,w,a){l>w||l===w&&d>a?(this.startLineNumber=w,this.startColumn=a,this.endLineNumber=l,this.endColumn=d):(this.startLineNumber=l,this.startColumn=d,this.endLineNumber=w,this.endColumn=a)}isEmpty(){return D.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return D.containsPosition(this,l)}static containsPosition(l,d){return!(d.lineNumber<l.startLineNumber||d.lineNumber>l.endLineNumber||d.lineNumber===l.startLineNumber&&d.column<l.startColumn||d.lineNumber===l.endLineNumber&&d.column>l.endColumn)}static strictContainsPosition(l,d){return!(d.lineNumber<l.startLineNumber||d.lineNumber>l.endLineNumber||d.lineNumber===l.startLineNumber&&d.column<=l.startColumn||d.lineNumber===l.endLineNumber&&d.column>=l.endColumn)}containsRange(l){return D.containsRange(this,l)}static containsRange(l,d){return!(d.startLineNumber<l.startLineNumber||d.endLineNumber<l.startLineNumber||d.startLineNumber>l.endLineNumber||d.endLineNumber>l.endLineNumber||d.startLineNumber===l.startLineNumber&&d.startColumn<l.startColumn||d.endLineNumber===l.endLineNumber&&d.endColumn>l.endColumn)}strictContainsRange(l){return D.strictContainsRange(this,l)}static strictContainsRange(l,d){return!(d.startLineNumber<l.startLineNumber||d.endLineNumber<l.startLineNumber||d.startLineNumber>l.endLineNumber||d.endLineNumber>l.endLineNumber||d.startLineNumber===l.startLineNumber&&d.startColumn<=l.startColumn||d.endLineNumber===l.endLineNumber&&d.endColumn>=l.endColumn)}plusRange(l){return D.plusRange(this,l)}static plusRange(l,d){let w,a,s,m;return d.startLineNumber<l.startLineNumber?(w=d.startLineNumber,a=d.startColumn):d.startLineNumber===l.startLineNumber?(w=d.startLineNumber,a=Math.min(d.startColumn,l.startColumn)):(w=l.startLineNumber,a=l.startColumn),d.endLineNumber>l.endLineNumber?(s=d.endLineNumber,m=d.endColumn):d.endLineNumber===l.endLineNumber?(s=d.endLineNumber,m=Math.max(d.endColumn,l.endColumn)):(s=l.endLineNumber,m=l.endColumn),new D(w,a,s,m)}intersectRanges(l){return D.intersectRanges(this,l)}static intersectRanges(l,d){let w=l.startLineNumber,a=l.startColumn,s=l.endLineNumber,m=l.endColumn;const e=d.startLineNumber,c=d.startColumn,f=d.endLineNumber,g=d.endColumn;return w<e?(w=e,a=c):w===e&&(a=Math.max(a,c)),s>f?(s=f,m=g):s===f&&(m=Math.min(m,g)),w>s||w===s&&a>m?null:new D(w,a,s,m)}equalsRange(l){return D.equalsRange(this,l)}static equalsRange(l,d){return!l&&!d?!0:!!l&&!!d&&l.startLineNumber===d.startLineNumber&&l.startColumn===d.startColumn&&l.endLineNumber===d.endLineNumber&&l.endColumn===d.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(l){return new M.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(l){return new M.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,d){return new D(this.startLineNumber,this.startColumn,l,d)}setStartPosition(l,d){return new D(l,d,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(l){return new D(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(l){return new D(l.endLineNumber,l.endColumn,l.endLineNumber,l.endColumn)}delta(l){return new D(this.startLineNumber+l,this.startColumn,this.endLineNumber+l,this.endColumn)}static fromPositions(l,d=l){return new D(l.lineNumber,l.column,d.lineNumber,d.column)}static lift(l){return l?new D(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,d){return!(l.endLineNumber<d.startLineNumber||l.endLineNumber===d.startLineNumber&&l.endColumn<d.startColumn||d.endLineNumber<l.startLineNumber||d.endLineNumber===l.startLineNumber&&d.endColumn<l.startColumn)}static areIntersecting(l,d){return!(l.endLineNumber<d.startLineNumber||l.endLineNumber===d.startLineNumber&&l.endColumn<=d.startColumn||d.endLineNumber<l.startLineNumber||d.endLineNumber===l.startLineNumber&&d.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,d){if(l&&d){const s=l.startLineNumber|0,m=d.startLineNumber|0;if(s===m){const e=l.startColumn|0,c=d.startColumn|0;if(e===c){const f=l.endLineNumber|0,g=d.endLineNumber|0;if(f===g){const _=l.endColumn|0,b=d.endColumn|0;return _-b}return f-g}return e-c}return s-m}return(l?1:0)-(d?1:0)}static compareRangesUsingEnds(l,d){return l.endLineNumber===d.endLineNumber?l.endColumn===d.endColumn?l.startLineNumber===d.startLineNumber?l.startColumn-d.startColumn:l.startLineNumber-d.startLineNumber:l.endColumn-d.endColumn:l.endLineNumber-d.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}n.Range=D}),X(J[12],Z([0,1,4,2]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class i{static fromRange(d){return new i(d.startLineNumber,d.endLineNumber)}static subtract(d,w){return w?d.startLineNumber<w.startLineNumber&&w.endLineNumberExclusive<d.endLineNumberExclusive?[new i(d.startLineNumber,w.startLineNumber),new i(w.endLineNumberExclusive,d.endLineNumberExclusive)]:w.startLineNumber<=d.startLineNumber&&d.endLineNumberExclusive<=w.endLineNumberExclusive?[]:w.endLineNumberExclusive<d.endLineNumberExclusive?[new i(Math.max(w.endLineNumberExclusive,d.startLineNumber),d.endLineNumberExclusive)]:[new i(d.startLineNumber,Math.min(w.startLineNumber,d.endLineNumberExclusive))]:[d]}static joinMany(d){if(d.length===0)return[];let w=d[0];for(let a=1;a<d.length;a++)w=this.join(w,d[a]);return w}static join(d,w){if(d.length===0)return w;if(w.length===0)return d;const a=[];let s=0,m=0,e=null;for(;s<d.length||m<w.length;){let c=null;if(s<d.length&&m<w.length){const f=d[s],g=w[m];f.startLineNumber<g.startLineNumber?(c=f,s++):(c=g,m++)}else s<d.length?(c=d[s],s++):(c=w[m],m++);e===null?e=c:e.endLineNumberExclusive>=c.startLineNumber?e=new i(e.startLineNumber,Math.max(e.endLineNumberExclusive,c.endLineNumberExclusive)):(a.push(e),e=c)}return e!==null&&a.push(e),a}static ofLength(d,w){return new i(d,d+w)}static deserialize(d){return new i(d[0],d[1])}constructor(d,w){if(d>w)throw new M.BugIndicatingError(`startLineNumber ${d} cannot be after endLineNumberExclusive ${w}`);this.startLineNumber=d,this.endLineNumberExclusive=w}contains(d){return this.startLineNumber<=d&&d<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(d){return new i(this.startLineNumber+d,this.endLineNumberExclusive+d)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(d){return new i(Math.min(this.startLineNumber,d.startLineNumber),Math.max(this.endLineNumberExclusive,d.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(d){const w=Math.max(this.startLineNumber,d.startLineNumber),a=Math.min(this.endLineNumberExclusive,d.endLineNumberExclusive);if(w<=a)return new i(w,a)}intersectsStrict(d){return this.startLineNumber<d.endLineNumberExclusive&&d.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(d){return this.startLineNumber<=d.endLineNumberExclusive&&d.startLineNumber<=this.endLineNumberExclusive}equals(d){return this.startLineNumber===d.startLineNumber&&this.endLineNumberExclusive===d.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(d){const w=[];for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)w.push(d(a));return w}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(d){return this.startLineNumber<=d&&d<this.endLineNumberExclusive}}n.LineRange=i}),X(J[35],Z([0,1,3,2]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(d,w,a,s){super(d,w,a,s),this.selectionStartLineNumber=d,this.selectionStartColumn=w,this.positionLineNumber=a,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return i.selectionsEqual(this,d)}static selectionsEqual(d,w){return d.selectionStartLineNumber===w.selectionStartLineNumber&&d.selectionStartColumn===w.selectionStartColumn&&d.positionLineNumber===w.positionLineNumber&&d.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,w){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,d,w):new i(d,w,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,w){return this.getDirection()===0?new i(d,w,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,d,w)}static fromPositions(d,w=d){return new i(d.lineNumber,d.column,w.lineNumber,w.column)}static fromRange(d,w){return w===0?new i(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new i(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new i(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,w){if(d&&!w||!d&&w)return!1;if(!d&&!w)return!0;if(d.length!==w.length)return!1;for(let a=0,s=d.length;a<s;a++)if(!this.selectionsEqual(d[a],w[a]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,w,a,s,m){return m===0?new i(d,w,a,s):new i(a,s,d,w)}}n.Selection=i}),X(J[36],Z([0,1,22]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends M.CharacterClassifier{constructor(d){super(0);for(let w=0,a=d.length;w<a;w++)this.set(d.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(l){const d={};return w=>(d.hasOwnProperty(w)||(d[w]=l(w)),d[w])}n.getMapForWordSeparators=i(l=>new D(l))}),X(J[23],Z([0,1,16,17]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(m+="\\"+e);return m+="\\s]+)",new RegExp(m,"g")}n.DEFAULT_WORD_REGEXP=i();function l(s){let m=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)m=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),m=new RegExp(s.source,e)}return m.lastIndex=0,m}n.ensureValidWordDefinition=l;const d=new D.LinkedList;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(s,m,e,c,f){if(f||(f=M.Iterable.first(d)),e.length>f.maxLen){let p=s-f.maxLen/2;return p<0?p=0:c+=p,e=e.substring(p,s+f.maxLen/2),w(s,m,e,c,f)}const g=Date.now(),_=s-1-c;let b=-1,N=null;for(let p=1;!(Date.now()-g>=f.timeBudget);p++){const A=_-f.windowSize*p;m.lastIndex=Math.max(0,A);const S=a(m,e,_,b);if(!S&&N||(N=S,A<=0))break;b=A}if(N){const p={word:N[0],startColumn:c+1+N.index,endColumn:c+1+N.index+N[0].length};return m.lastIndex=0,p}return null}n.getWordAtText=w;function a(s,m,e,c){let f;for(;f=s.exec(m);){const g=f.index||0;if(g<=e&&s.lastIndex>=e)return f;if(c>0&&g>c)return null}return null}}),X(J[8],Z([0,1,4,6]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,m){return new i([new l(new D.OffsetRange(0,s.length),new D.OffsetRange(0,m.length))],!1)}static trivialTimedOut(s,m){return new i([new l(new D.OffsetRange(0,s.length),new D.OffsetRange(0,m.length))],!0)}constructor(s,m){this.diffs=s,this.hitTimeout=m}}n.DiffAlgorithmResult=i;class l{constructor(s,m){this.seq1Range=s,this.seq2Range=m}reverse(){return new l(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new l(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new l(this.seq1Range.delta(s),this.seq2Range.delta(s))}}n.SequenceDiff=l;class d{isValid(){return!0}}n.InfiniteTimeout=d,d.instance=new d;class w{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new M.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=w}),X(J[37],Z([0,1,6,8]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(s,m,e){let c=e;return c=d(s,m,c),c=w(s,m,c),c}n.optimizeSequenceDiffs=i;function l(s,m,e){const c=[];for(const f of e){const g=c[c.length-1];if(!g){c.push(f);continue}f.seq1Range.start-g.seq1Range.endExclusive<=2||f.seq2Range.start-g.seq2Range.endExclusive<=2?c[c.length-1]=new D.SequenceDiff(g.seq1Range.join(f.seq1Range),g.seq2Range.join(f.seq2Range)):c.push(f)}return c}n.smoothenSequenceDiffs=l;function d(s,m,e){if(e.length===0)return e;const c=[];c.push(e[0]);for(let g=1;g<e.length;g++){const _=c[c.length-1];let b=e[g];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const N=b.seq1Range.start-_.seq1Range.endExclusive;let p;for(p=1;p<=N&&!(s.getElement(b.seq1Range.start-p)!==s.getElement(b.seq1Range.endExclusive-p)||m.getElement(b.seq2Range.start-p)!==m.getElement(b.seq2Range.endExclusive-p));p++);if(p--,p===N){c[c.length-1]=new D.SequenceDiff(new M.OffsetRange(_.seq1Range.start,b.seq1Range.endExclusive-N),new M.OffsetRange(_.seq2Range.start,b.seq2Range.endExclusive-N));continue}b=b.delta(-p)}c.push(b)}const f=[];for(let g=0;g<c.length-1;g++){const _=c[g+1];let b=c[g];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const N=_.seq1Range.start-b.seq1Range.endExclusive;let p;for(p=0;p<N&&!(s.getElement(b.seq1Range.start+p)!==s.getElement(b.seq1Range.endExclusive+p)||m.getElement(b.seq2Range.start+p)!==m.getElement(b.seq2Range.endExclusive+p));p++);if(p===N){c[g+1]=new D.SequenceDiff(new M.OffsetRange(b.seq1Range.start+N,_.seq1Range.endExclusive),new M.OffsetRange(b.seq2Range.start+N,_.seq2Range.endExclusive));continue}p>0&&(b=b.delta(p))}f.push(b)}return c.length>0&&f.push(c[c.length-1]),f}n.joinSequenceDiffs=d;function w(s,m,e){if(!s.getBoundaryScore||!m.getBoundaryScore)return e;for(let c=0;c<e.length;c++){const f=c>0?e[c-1]:void 0,g=e[c],_=c+1<e.length?e[c+1]:void 0,b=new M.OffsetRange(f?f.seq1Range.start+1:0,_?_.seq1Range.endExclusive-1:s.length),N=new M.OffsetRange(f?f.seq2Range.start+1:0,_?_.seq2Range.endExclusive-1:m.length);g.seq1Range.isEmpty?e[c]=a(g,s,m,b,N):g.seq2Range.isEmpty&&(e[c]=a(g.reverse(),m,s,N,b).reverse())}return e}n.shiftSequenceDiffs=w;function a(s,m,e,c,f){let _=1;for(;s.seq1Range.start-_>=c.start&&s.seq2Range.start-_>=f.start&&e.getElement(s.seq2Range.start-_)===e.getElement(s.seq2Range.endExclusive-_)&&_<100;)_++;_--;let b=0;for(;s.seq1Range.start+b<c.endExclusive&&s.seq2Range.endExclusive+b<f.endExclusive&&e.getElement(s.seq2Range.start+b)===e.getElement(s.seq2Range.endExclusive+b)&&b<100;)b++;if(_===0&&b===0)return s;let N=0,p=-1;for(let A=-_;A<=b;A++){const S=s.seq2Range.start+A,h=s.seq2Range.endExclusive+A,r=s.seq1Range.start+A,o=m.getBoundaryScore(r)+e.getBoundaryScore(S)+e.getBoundaryScore(h);o>p&&(p=o,N=A)}return s.delta(N)}}),X(J[38],Z([0,1,6,8]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,m,e=D.InfiniteTimeout.instance){if(s.length===0||m.length===0)return D.DiffAlgorithmResult.trivial(s,m);function c(h,r){for(;h<s.length&&r<m.length&&s.getElement(h)===m.getElement(r);)h++,r++;return h}let f=0;const g=new d;g.set(0,c(0,0));const _=new w;_.set(0,g.get(0)===0?null:new l(null,0,0,g.get(0)));let b=0;e:for(;;){if(f++,!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(s,m);const h=-Math.min(f,m.length+f%2),r=Math.min(f,s.length+f%2);for(b=h;b<=r;b+=2){const o=b===r?-1:g.get(b+1),u=b===h?-1:g.get(b-1)+1,L=Math.min(Math.max(o,u),s.length),C=L-b;if(L>s.length||C>m.length)continue;const v=c(L,C);g.set(b,v);const E=L===o?_.get(b+1):_.get(b-1);if(_.set(b,v!==L?new l(E,L,C,v-L):E),g.get(b)===s.length&&g.get(b)-b===m.length)break e}}let N=_.get(b);const p=[];let A=s.length,S=m.length;for(;;){const h=N?N.x+N.length:0,r=N?N.y+N.length:0;if((h!==A||r!==S)&&p.push(new D.SequenceDiff(new M.OffsetRange(h,A),new M.OffsetRange(r,S))),!N)break;A=N.x,S=N.y,N=N.prev}return p.reverse(),new D.DiffAlgorithmResult(p,!1)}}n.MyersDiffAlgorithm=i;class l{constructor(s,m,e,c){this.prev=s,this.x=m,this.y=e,this.length=c}}class d{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,m){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=m}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=m}}}class w{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,m){s<0?(s=-s-1,this.negativeArr[s]=m):this.positiveArr[s]=m}}}),X(J[39],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class M{constructor(i,l){this.width=i,this.height=l,this.array=[],this.array=new Array(i*l)}get(i,l){return this.array[i+l*this.width]}set(i,l,d){this.array[i+l*this.width]=d}}n.Array2D=M}),X(J[40],Z([0,1,6,8,39]),function(O,n,M,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class l{compute(w,a,s=D.InfiniteTimeout.instance,m){if(w.length===0||a.length===0)return D.DiffAlgorithmResult.trivial(w,a);const e=new i.Array2D(w.length,a.length),c=new i.Array2D(w.length,a.length),f=new i.Array2D(w.length,a.length);for(let S=0;S<w.length;S++)for(let h=0;h<a.length;h++){if(!s.isValid())return D.DiffAlgorithmResult.trivialTimedOut(w,a);const r=S===0?0:e.get(S-1,h),o=h===0?0:e.get(S,h-1);let u;w.getElement(S)===a.getElement(h)?(S===0||h===0?u=0:u=e.get(S-1,h-1),S>0&&h>0&&c.get(S-1,h-1)===3&&(u+=f.get(S-1,h-1)),u+=m?m(S,h):1):u=-1;const L=Math.max(r,o,u);if(L===u){const C=S>0&&h>0?f.get(S-1,h-1):0;f.set(S,h,C+1),c.set(S,h,3)}else L===r?(f.set(S,h,0),c.set(S,h,1)):L===o&&(f.set(S,h,0),c.set(S,h,2));e.set(S,h,L)}const g=[];let _=w.length,b=a.length;function N(S,h){(S+1!==_||h+1!==b)&&g.push(new D.SequenceDiff(new M.OffsetRange(S+1,_),new M.OffsetRange(h+1,b))),_=S,b=h}let p=w.length-1,A=a.length-1;for(;p>=0&&A>=0;)c.get(p,A)===3?(N(p,A),p--,A--):c.get(p,A)===1?p--:A--;return N(-1,-1),g.reverse(),new D.DiffAlgorithmResult(g,!1)}}n.DynamicProgrammingDiffing=l}),X(J[24],Z([0,1,12]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class D{constructor(s,m,e){this.changes=s,this.moves=m,this.hitTimeout=e}}n.LinesDiff=D;class i{static inverse(s,m,e){const c=[];let f=1,g=1;for(const b of s){const N=new i(new M.LineRange(f,b.originalRange.startLineNumber),new M.LineRange(g,b.modifiedRange.startLineNumber),void 0);N.modifiedRange.isEmpty||c.push(N),f=b.originalRange.endLineNumberExclusive,g=b.modifiedRange.endLineNumberExclusive}const _=new i(new M.LineRange(f,m+1),new M.LineRange(g,e+1),void 0);return _.modifiedRange.isEmpty||c.push(_),c}constructor(s,m,e){this.originalRange=s,this.modifiedRange=m,this.innerChanges=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(m=>m.flip()))}}n.LineRangeMapping=i;class l{constructor(s,m){this.originalRange=s,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new l(this.modifiedRange,this.originalRange)}}n.RangeMapping=l;class d{constructor(s,m){this.originalRange=s,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new d(this.modifiedRange,this.originalRange)}}n.SimpleLineRangeMapping=d;class w{constructor(s,m){this.lineRangeMapping=s,this.changes=m}flip(){return new w(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=w}),X(J[41],Z([0,1,19,24,5,2,9,12]),function(O,n,M,D,i,l,d,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const a=3;class s{computeDiff(h,r,o){var u;const C=new b(h,r,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),v=[];let E=null;for(const y of C.changes){let R;y.originalEndLineNumber===0?R=new w.LineRange(y.originalStartLineNumber+1,y.originalStartLineNumber+1):R=new w.LineRange(y.originalStartLineNumber,y.originalEndLineNumber+1);let F;y.modifiedEndLineNumber===0?F=new w.LineRange(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):F=new w.LineRange(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let T=new D.LineRangeMapping(R,F,(u=y.charChanges)===null||u===void 0?void 0:u.map(P=>new D.RangeMapping(new l.Range(P.originalStartLineNumber,P.originalStartColumn,P.originalEndLineNumber,P.originalEndColumn),new l.Range(P.modifiedStartLineNumber,P.modifiedStartColumn,P.modifiedEndLineNumber,P.modifiedEndColumn))));E&&(E.modifiedRange.endLineNumberExclusive===T.modifiedRange.startLineNumber||E.originalRange.endLineNumberExclusive===T.originalRange.startLineNumber)&&(T=new D.LineRangeMapping(E.originalRange.join(T.originalRange),E.modifiedRange.join(T.modifiedRange),E.innerChanges&&T.innerChanges?E.innerChanges.concat(T.innerChanges):void 0),v.pop()),v.push(T),E=T}return(0,d.assertFn)(()=>(0,d.checkAdjacentItems)(v,(y,R)=>R.originalRange.startLineNumber-y.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-y.modifiedRange.endLineNumberExclusive&&y.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&y.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),new D.LinesDiff(v,[],C.quitEarly)}}n.SmartLinesDiffComputer=s;function m(S,h,r,o){return new M.LcsDiff(S,h,r).ComputeDiff(o)}class e{constructor(h){const r=[],o=[];for(let u=0,L=h.length;u<L;u++)r[u]=N(h[u],1),o[u]=p(h[u],1);this.lines=h,this._startColumns=r,this._endColumns=o}getElements(){const h=[];for(let r=0,o=this.lines.length;r<o;r++)h[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return h}getStrictElement(h){return this.lines[h]}getStartLineNumber(h){return h+1}getEndLineNumber(h){return h+1}createCharSequence(h,r,o){const u=[],L=[],C=[];let v=0;for(let E=r;E<=o;E++){const y=this.lines[E],R=h?this._startColumns[E]:1,F=h?this._endColumns[E]:y.length+1;for(let T=R;T<F;T++)u[v]=y.charCodeAt(T-1),L[v]=E+1,C[v]=T,v++;!h&&E<o&&(u[v]=10,L[v]=E+1,C[v]=y.length+1,v++)}return new c(u,L,C)}}class c{constructor(h,r,o){this._charCodes=h,this._lineNumbers=r,this._columns=o}toString(){return"["+this._charCodes.map((h,r)=>(h===10?"\\n":String.fromCharCode(h))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(h,r){if(h<0||h>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(h){return h>0&&h===this._lineNumbers.length?this.getEndLineNumber(h-1):(this._assertIndex(h,this._lineNumbers),this._lineNumbers[h])}getEndLineNumber(h){return h===-1?this.getStartLineNumber(h+1):(this._assertIndex(h,this._lineNumbers),this._charCodes[h]===10?this._lineNumbers[h]+1:this._lineNumbers[h])}getStartColumn(h){return h>0&&h===this._columns.length?this.getEndColumn(h-1):(this._assertIndex(h,this._columns),this._columns[h])}getEndColumn(h){return h===-1?this.getStartColumn(h+1):(this._assertIndex(h,this._columns),this._charCodes[h]===10?1:this._columns[h]+1)}}class f{constructor(h,r,o,u,L,C,v,E){this.originalStartLineNumber=h,this.originalStartColumn=r,this.originalEndLineNumber=o,this.originalEndColumn=u,this.modifiedStartLineNumber=L,this.modifiedStartColumn=C,this.modifiedEndLineNumber=v,this.modifiedEndColumn=E}static createFromDiffChange(h,r,o){const u=r.getStartLineNumber(h.originalStart),L=r.getStartColumn(h.originalStart),C=r.getEndLineNumber(h.originalStart+h.originalLength-1),v=r.getEndColumn(h.originalStart+h.originalLength-1),E=o.getStartLineNumber(h.modifiedStart),y=o.getStartColumn(h.modifiedStart),R=o.getEndLineNumber(h.modifiedStart+h.modifiedLength-1),F=o.getEndColumn(h.modifiedStart+h.modifiedLength-1);return new f(u,L,C,v,E,y,R,F)}}function g(S){if(S.length<=1)return S;const h=[S[0]];let r=h[0];for(let o=1,u=S.length;o<u;o++){const L=S[o],C=L.originalStart-(r.originalStart+r.originalLength),v=L.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(C,v)<a?(r.originalLength=L.originalStart+L.originalLength-r.originalStart,r.modifiedLength=L.modifiedStart+L.modifiedLength-r.modifiedStart):(h.push(L),r=L)}return h}class _{constructor(h,r,o,u,L){this.originalStartLineNumber=h,this.originalEndLineNumber=r,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=u,this.charChanges=L}static createFromDiffResult(h,r,o,u,L,C,v){let E,y,R,F,T;if(r.originalLength===0?(E=o.getStartLineNumber(r.originalStart)-1,y=0):(E=o.getStartLineNumber(r.originalStart),y=o.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(R=u.getStartLineNumber(r.modifiedStart)-1,F=0):(R=u.getStartLineNumber(r.modifiedStart),F=u.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),C&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&L()){const P=o.createCharSequence(h,r.originalStart,r.originalStart+r.originalLength-1),U=u.createCharSequence(h,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(P.getElements().length>0&&U.getElements().length>0){let W=m(P,U,L,!0).changes;v&&(W=g(W)),T=[];for(let H=0,I=W.length;H<I;H++)T.push(f.createFromDiffChange(W[H],P,U))}}return new _(E,y,R,F,T)}}class b{constructor(h,r,o){this.shouldComputeCharChanges=o.shouldComputeCharChanges,this.shouldPostProcessCharChanges=o.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=o.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=o.shouldMakePrettyDiff,this.originalLines=h,this.modifiedLines=r,this.original=new e(h),this.modified=new e(r),this.continueLineDiff=A(o.maxComputationTime),this.continueCharDiff=A(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const h=m(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=h.changes,o=h.quitEarly;if(this.shouldIgnoreTrimWhitespace){const v=[];for(let E=0,y=r.length;E<y;E++)v.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:o,changes:v}}const u=[];let L=0,C=0;for(let v=-1,E=r.length;v<E;v++){const y=v+1<E?r[v+1]:null,R=y?y.originalStart:this.originalLines.length,F=y?y.modifiedStart:this.modifiedLines.length;for(;L<R&&C<F;){const T=this.originalLines[L],P=this.modifiedLines[C];if(T!==P){{let U=N(T,1),W=N(P,1);for(;U>1&&W>1;){const H=T.charCodeAt(U-2),I=P.charCodeAt(W-2);if(H!==I)break;U--,W--}(U>1||W>1)&&this._pushTrimWhitespaceCharChange(u,L+1,1,U,C+1,1,W)}{let U=p(T,1),W=p(P,1);const H=T.length+1,I=P.length+1;for(;U<H&&W<I;){const x=T.charCodeAt(U-1),q=T.charCodeAt(W-1);if(x!==q)break;U++,W++}(U<H||W<I)&&this._pushTrimWhitespaceCharChange(u,L+1,U,H,C+1,W,I)}}L++,C++}y&&(u.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,y,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),L+=y.originalLength,C+=y.modifiedLength)}return{quitEarly:o,changes:u}}_pushTrimWhitespaceCharChange(h,r,o,u,L,C,v){if(this._mergeTrimWhitespaceCharChange(h,r,o,u,L,C,v))return;let E;this.shouldComputeCharChanges&&(E=[new f(r,o,r,u,L,C,L,v)]),h.push(new _(r,r,L,L,E))}_mergeTrimWhitespaceCharChange(h,r,o,u,L,C,v){const E=h.length;if(E===0)return!1;const y=h[E-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===r&&y.modifiedEndLineNumber===L?(this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new f(r,o,r,u,L,C,L,v)),!0):y.originalEndLineNumber+1===r&&y.modifiedEndLineNumber+1===L?(y.originalEndLineNumber=r,y.modifiedEndLineNumber=L,this.shouldComputeCharChanges&&y.charChanges&&y.charChanges.push(new f(r,o,r,u,L,C,L,v)),!0):!1}}n.DiffComputer=b;function N(S,h){const r=i.firstNonWhitespaceIndex(S);return r===-1?h:r+1}function p(S,h){const r=i.lastNonWhitespaceIndex(S);return r===-1?h:r+2}function A(S){if(S===0)return()=>!0;const h=Date.now();return()=>Date.now()-h<S}}),X(J[42],Z([0,1,9,12,6,3,2,8,40,37,38,24]),function(O,n,M,D,i,l,d,w,a,s,m,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class c{constructor(){this.dynamicProgrammingDiffing=new a.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new m.MyersDiffAlgorithm}computeDiff(R,F,T){if(R.length===1&&R[0].length===0||F.length===1&&F[0].length===0)return{changes:[new e.LineRangeMapping(new D.LineRange(1,R.length+1),new D.LineRange(1,F.length+1),[new e.RangeMapping(new d.Range(1,1,R.length,R[0].length+1),new d.Range(1,1,F.length,F[0].length+1))])],hitTimeout:!1,moves:[]};const P=T.maxComputationTimeMs===0?w.InfiniteTimeout.instance:new w.DateTimeout(T.maxComputationTimeMs),U=!T.ignoreTrimWhitespace,W=new Map;function H(se){let ae=W.get(se);return ae===void 0&&(ae=W.size,W.set(se,ae)),ae}const I=R.map(se=>H(se.trim())),x=F.map(se=>H(se.trim())),q=new p(I,R),z=new p(x,F),t=(()=>q.length+z.length<1500?this.dynamicProgrammingDiffing.compute(q,z,P,(se,ae)=>R[se]===F[ae]?F[ae].length===0?.1:1+Math.log(1+F[ae].length):.99):this.myersDiffingAlgorithm.compute(q,z))();let ne=t.diffs,ie=t.hitTimeout;ne=(0,s.optimizeSequenceDiffs)(q,z,ne);const he=[],me=se=>{if(U)for(let ae=0;ae<se;ae++){const Q=be+ae,$=pe+ae;if(R[Q]!==F[$]){const Y=this.refineDiff(R,F,new w.SequenceDiff(new i.OffsetRange(Q,Q+1),new i.OffsetRange($,$+1)),P,U);for(const j of Y.mappings)he.push(j);Y.hitTimeout&&(ie=!0)}}};let be=0,pe=0;for(const se of ne){(0,M.assertFn)(()=>se.seq1Range.start-be===se.seq2Range.start-pe);const ae=se.seq1Range.start-be;me(ae),be=se.seq1Range.endExclusive,pe=se.seq2Range.endExclusive;const Q=this.refineDiff(R,F,se,P,U);Q.hitTimeout&&(ie=!0);for(const $ of Q.mappings)he.push($)}me(R.length-be);const Le=_(he,R,F),Ce=[];if(T.computeMoves){const se=Le.filter(Q=>Q.modifiedRange.isEmpty&&Q.originalRange.length>=3).map(Q=>new E(Q.originalRange,R)),ae=new Set(Le.filter(Q=>Q.originalRange.isEmpty&&Q.modifiedRange.length>=3).map(Q=>new E(Q.modifiedRange,F)));for(const Q of se){let $=-1,Y;for(const j of ae){const K=Q.computeSimilarity(j);K>$&&($=K,Y=j)}if($>.9&&Y){const j=this.refineDiff(R,F,new w.SequenceDiff(new i.OffsetRange(Q.range.startLineNumber-1,Q.range.endLineNumberExclusive-1),new i.OffsetRange(Y.range.startLineNumber-1,Y.range.endLineNumberExclusive-1)),P,U),K=_(j.mappings,R,F,!0);ae.delete(Y),Ce.push(new e.MovedText(new e.SimpleLineRangeMapping(Q.range,Y.range),K))}}}return new e.LinesDiff(Le,Ce,ie)}refineDiff(R,F,T,P,U){const W=new S(R,T.seq1Range,U),H=new S(F,T.seq2Range,U),I=W.length+H.length<500?this.dynamicProgrammingDiffing.compute(W,H,P):this.myersDiffingAlgorithm.compute(W,H,P);let x=I.diffs;return x=(0,s.optimizeSequenceDiffs)(W,H,x),x=f(W,H,x),x=(0,s.smoothenSequenceDiffs)(W,H,x),{mappings:x.map(z=>new e.RangeMapping(W.translateRange(z.seq1Range),H.translateRange(z.seq2Range))),hitTimeout:I.hitTimeout}}}n.StandardLinesDiffComputer=c;function f(y,R,F){const T=[];let P;function U(){if(!P)return;const H=P.s1Range.length-P.deleted,I=P.s2Range.length-P.added;Math.max(P.deleted,P.added)+(P.count-1)>H&&T.push(new w.SequenceDiff(P.s1Range,P.s2Range)),P=void 0}for(const H of F){let I=function(ne,ie){var he,me,be,pe;if(!P||!P.s1Range.containsRange(ne)||!P.s2Range.containsRange(ie))if(P&&!(P.s1Range.endExclusive<ne.start&&P.s2Range.endExclusive<ie.start)){const se=i.OffsetRange.tryCreate(P.s1Range.endExclusive,ne.start),ae=i.OffsetRange.tryCreate(P.s2Range.endExclusive,ie.start);P.deleted+=(he=se?.length)!==null&&he!==void 0?he:0,P.added+=(me=ae?.length)!==null&&me!==void 0?me:0,P.s1Range=P.s1Range.join(ne),P.s2Range=P.s2Range.join(ie)}else U(),P={added:0,deleted:0,count:0,s1Range:ne,s2Range:ie};const Le=ne.intersect(H.seq1Range),Ce=ie.intersect(H.seq2Range);P.count++,P.deleted+=(be=Le?.length)!==null&&be!==void 0?be:0,P.added+=(pe=Ce?.length)!==null&&pe!==void 0?pe:0};const x=y.findWordContaining(H.seq1Range.start-1),q=R.findWordContaining(H.seq2Range.start-1),z=y.findWordContaining(H.seq1Range.endExclusive),t=R.findWordContaining(H.seq2Range.endExclusive);x&&z&&q&&t&&x.equals(z)&&q.equals(t)?I(x,q):(x&&q&&I(x,q),z&&t&&I(z,t))}return U(),g(F,T)}function g(y,R){const F=[];for(;y.length>0||R.length>0;){const T=y[0],P=R[0];let U;T&&(!P||T.seq1Range.start<P.seq1Range.start)?U=y.shift():U=R.shift(),F.length>0&&F[F.length-1].seq1Range.endExclusive>=U.seq1Range.start?F[F.length-1]=F[F.length-1].join(U):F.push(U)}return F}function _(y,R,F,T=!1){const P=[];for(const U of N(y.map(W=>b(W,R,F)),(W,H)=>W.originalRange.overlapOrTouch(H.originalRange)||W.modifiedRange.overlapOrTouch(H.modifiedRange))){const W=U[0],H=U[U.length-1];P.push(new e.LineRangeMapping(W.originalRange.join(H.originalRange),W.modifiedRange.join(H.modifiedRange),U.map(I=>I.innerChanges[0])))}return(0,M.assertFn)(()=>!T&&P.length>0&&P[0].originalRange.startLineNumber!==P[0].modifiedRange.startLineNumber?!1:(0,M.checkAdjacentItems)(P,(U,W)=>W.originalRange.startLineNumber-U.originalRange.endLineNumberExclusive===W.modifiedRange.startLineNumber-U.modifiedRange.endLineNumberExclusive&&U.originalRange.endLineNumberExclusive<W.originalRange.startLineNumber&&U.modifiedRange.endLineNumberExclusive<W.modifiedRange.startLineNumber)),P}n.lineRangeMappingFromRangeMappings=_;function b(y,R,F){let T=0,P=0;y.modifiedRange.endColumn===1&&y.originalRange.endColumn===1&&y.originalRange.startLineNumber+T<=y.originalRange.endLineNumber&&y.modifiedRange.startLineNumber+T<=y.modifiedRange.endLineNumber&&(P=-1),y.modifiedRange.startColumn-1>=F[y.modifiedRange.startLineNumber-1].length&&y.originalRange.startColumn-1>=R[y.originalRange.startLineNumber-1].length&&y.originalRange.startLineNumber<=y.originalRange.endLineNumber+P&&y.modifiedRange.startLineNumber<=y.modifiedRange.endLineNumber+P&&(T=1);const U=new D.LineRange(y.originalRange.startLineNumber+T,y.originalRange.endLineNumber+1+P),W=new D.LineRange(y.modifiedRange.startLineNumber+T,y.modifiedRange.endLineNumber+1+P);return new e.LineRangeMapping(U,W,[y])}n.getLineRangeMapping=b;function*N(y,R){let F,T;for(const P of y)T!==void 0&&R(T,P)?F.push(P):(F&&(yield F),F=[P]),T=P;F&&(yield F)}class p{constructor(R,F){this.trimmedHash=R,this.lines=F}getElement(R){return this.trimmedHash[R]}get length(){return this.trimmedHash.length}getBoundaryScore(R){const F=R===0?0:A(this.lines[R-1]),T=R===this.lines.length?0:A(this.lines[R]);return 1e3-(F+T)}}n.LineSequence=p;function A(y){let R=0;for(;R<y.length&&(y.charCodeAt(R)===32||y.charCodeAt(R)===9);)R++;return R}class S{constructor(R,F,T){this.lines=R,this.considerWhitespaceChanges=T,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let P=!1;F.start>0&&F.endExclusive>=R.length&&(F=new i.OffsetRange(F.start-1,F.endExclusive),P=!0),this.lineRange=F;for(let U=this.lineRange.start;U<this.lineRange.endExclusive;U++){let W=R[U],H=0;if(P)H=W.length,W="",P=!1;else if(!T){const I=W.trimStart();H=W.length-I.length,W=I.trimEnd()}this.offsetByLine.push(H);for(let I=0;I<W.length;I++)this.elements.push(W.charCodeAt(I));U<R.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[U-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(R=>String.fromCharCode(R)).join("")}getElement(R){return this.elements[R]}get length(){return this.elements.length}getBoundaryScore(R){const F=u(R>0?this.elements[R-1]:-1),T=u(R<this.elements.length?this.elements[R]:-1);if(F===6&&T===7)return 0;let P=0;return F!==T&&(P+=10,T===1&&(P+=1)),P+=o(F),P+=o(T),P}translateOffset(R){if(this.lineRange.isEmpty)return new l.Position(this.lineRange.start+1,1);let F=0,T=this.firstCharOffsetByLineMinusOne.length;for(;F<T;){const U=Math.floor((F+T)/2);this.firstCharOffsetByLineMinusOne[U]>R?T=U:F=U+1}const P=F===0?0:this.firstCharOffsetByLineMinusOne[F-1];return new l.Position(this.lineRange.start+F+1,R-P+1+this.offsetByLine[F])}translateRange(R){return d.Range.fromPositions(this.translateOffset(R.start),this.translateOffset(R.endExclusive))}findWordContaining(R){if(R<0||R>=this.elements.length||!h(this.elements[R]))return;let F=R;for(;F>0&&h(this.elements[F-1]);)F--;let T=R;for(;T<this.elements.length&&h(this.elements[T]);)T++;return new i.OffsetRange(F,T)}}function h(y){return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57}const r={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function o(y){return r[y]}function u(y){return y===10?7:y===13?6:L(y)?5:y>=97&&y<=122?0:y>=65&&y<=90?1:y>=48&&y<=57?2:y===-1?3:4}function L(y){return y===32||y===9}const C=new Map;function v(y){let R=C.get(y);return R===void 0&&(R=C.size,C.set(y,R)),R}class E{constructor(R,F){this.range=R,this.lines=F,this.histogram=[];let T=0;for(let P=R.startLineNumber-1;P<R.endLineNumberExclusive-1;P++){const U=F[P];for(let H=0;H<U.length;H++){T++;const I=U[H],x=v(I);this.histogram[x]=(this.histogram[x]||0)+1}T++;const W=v(`
`);this.histogram[W]=(this.histogram[W]||0)+1}this.totalCount=T}computeSimilarity(R){var F,T;let P=0;const U=Math.max(this.histogram.length,R.histogram.length);for(let W=0;W<U;W++)P+=Math.abs(((F=this.histogram[W])!==null&&F!==void 0?F:0)-((T=R.histogram[W])!==null&&T!==void 0?T:0));return 1-P/(this.totalCount+R.totalCount)}}}),X(J[43],Z([0,1,41,42]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new M.SmartLinesDiffComputer,getAdvanced:()=>new D.StandardLinesDiffComputer}}),X(J[44],Z([0,1,28]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function D(c){const f=[];for(const g of c){const _=Number(g);(_||_===0&&g.replace(/\s/g,"")!=="")&&f.push(_)}return f}function i(c,f,g,_){return{red:c/255,blue:g/255,green:f/255,alpha:_}}function l(c,f){const g=f.index,_=f[0].length;if(!g)return;const b=c.positionAt(g);return{startLineNumber:b.lineNumber,startColumn:b.column,endLineNumber:b.lineNumber,endColumn:b.column+_}}function d(c,f){if(!c)return;const g=M.Color.Format.CSS.parseHex(f);if(g)return{range:c,color:i(g.rgba.r,g.rgba.g,g.rgba.b,g.rgba.a)}}function w(c,f,g){if(!c||f.length!==1)return;const b=f[0].values(),N=D(b);return{range:c,color:i(N[0],N[1],N[2],g?N[3]:1)}}function a(c,f,g){if(!c||f.length!==1)return;const b=f[0].values(),N=D(b),p=new M.Color(new M.HSLA(N[0],N[1]/100,N[2]/100,g?N[3]:1));return{range:c,color:i(p.rgba.r,p.rgba.g,p.rgba.b,p.rgba.a)}}function s(c,f){return typeof c=="string"?[...c.matchAll(f)]:c.findMatches(f)}function m(c){const f=[],_=s(c,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(_.length>0)for(const b of _){const N=b.filter(h=>h!==void 0),p=N[1],A=N[2];if(!A)continue;let S;if(p==="rgb"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=w(l(c,b),s(A,h),!1)}else if(p==="rgba"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=w(l(c,b),s(A,h),!0)}else if(p==="hsl"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=a(l(c,b),s(A,h),!1)}else if(p==="hsla"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=a(l(c,b),s(A,h),!0)}else p==="#"&&(S=d(l(c,b),p+A));S&&f.push(S)}return f}function e(c){return!c||typeof c.getValue!="function"||typeof c.positionAt!="function"?[]:m(c)}n.computeDefaultDocumentColors=e}),X(J[45],Z([0,1,22]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(c,f,g){const _=new Uint8Array(c*f);for(let b=0,N=c*f;b<N;b++)_[b]=g;this._data=_,this.rows=c,this.cols=f}get(c,f){return this._data[c*this.cols+f]}set(c,f,g){this._data[c*this.cols+f]=g}}class i{constructor(c){let f=0,g=0;for(let b=0,N=c.length;b<N;b++){const[p,A,S]=c[b];A>f&&(f=A),p>g&&(g=p),S>g&&(g=S)}f++,g++;const _=new D(g,f,0);for(let b=0,N=c.length;b<N;b++){const[p,A,S]=c[b];_.set(p,A,S)}this._states=_,this._maxCharCode=f}nextState(c,f){return f<0||f>=this._maxCharCode?0:this._states.get(c,f)}}n.StateMachine=i;let l=null;function d(){return l===null&&(l=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let w=null;function a(){if(w===null){w=new M.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<e.length;f++)w.set(e.charCodeAt(f),1);const c=".,;:";for(let f=0;f<c.length;f++)w.set(c.charCodeAt(f),2)}return w}class s{static _createLink(c,f,g,_,b){let N=b-1;do{const p=f.charCodeAt(N);if(c.get(p)!==2)break;N--}while(N>_);if(_>0){const p=f.charCodeAt(_-1),A=f.charCodeAt(N);(p===40&&A===41||p===91&&A===93||p===123&&A===125)&&N--}return{range:{startLineNumber:g,startColumn:_+1,endLineNumber:g,endColumn:N+2},url:f.substring(_,N+1)}}static computeLinks(c,f=d()){const g=a(),_=[];for(let b=1,N=c.getLineCount();b<=N;b++){const p=c.getLineContent(b),A=p.length;let S=0,h=0,r=0,o=1,u=!1,L=!1,C=!1,v=!1;for(;S<A;){let E=!1;const y=p.charCodeAt(S);if(o===13){let R;switch(y){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:C=!0,L=!0,R=0;break;case 93:C=!1,R=L?0:1;break;case 123:v=!0,R=0;break;case 125:R=v?0:1;break;case 39:case 34:case 96:r===y?R=1:r===39||r===34||r===96?R=0:R=1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=C?0:1;break;default:R=g.get(y)}R===1&&(_.push(s._createLink(g,p,b,h,S)),E=!0)}else if(o===12){let R;y===91?(L=!0,R=0):R=g.get(y),R===1?E=!0:o=13}else o=f.nextState(o,y),o===0&&(E=!0);E&&(o=1,u=!1,L=!1,v=!1,h=S+1,r=y),S++}o===13&&_.push(s._createLink(g,p,b,h,A))}return _}}n.LinkComputer=s;function m(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=m}),X(J[46],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,l,d,w,a){if(i&&l){const s=this.doNavigateValueSet(l,a);if(s)return{range:i,value:s}}if(d&&w){const s=this.doNavigateValueSet(w,a);if(s)return{range:d,value:s}}return null}doNavigateValueSet(i,l){const d=this.numberReplace(i,l);return d!==null?d:this.textReplace(i,l)}numberReplace(i,l){const d=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let w=Number(i);const a=parseFloat(i);return!isNaN(w)&&!isNaN(a)&&w===a?w===0&&!l?null:(w=Math.floor(w*d),w+=l?d:-d,String(w/d)):null}textReplace(i,l){return this.valueSetsReplace(this._defaultValueSet,i,l)}valueSetsReplace(i,l,d){let w=null;for(let a=0,s=i.length;w===null&&a<s;a++)w=this.valueSetReplace(i[a],l,d);return w}valueSetReplace(i,l,d){let w=i.indexOf(l);return w>=0?(w+=d?1:-1,w<0?w=i.length-1:w%=i.length,i[w]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),X(J[47],Z([0,1,11]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var D;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var l;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(l||(n.MinimapPosition=l={}));var d;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(d||(n.InjectedTextCursorStops=d={}));class w{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),_.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,_.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!_.insertSpaces,this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=!!_.trimAutoWhitespace,this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this._indentSizeIsTabSize===_._indentSizeIsTabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}n.TextModelResolvedOptions=w;class a{constructor(_,b){this._findMatchBrand=void 0,this.range=_,this.matches=b}}n.FindMatch=a;function s(g){return g&&typeof g.read=="function"}n.isITextSnapshot=s;class m{constructor(_,b,N,p,A,S){this.identifier=_,this.range=b,this.text=N,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=A,this._isTracked=S}}n.ValidAnnotatedEditOperation=m;class e{constructor(_,b,N){this.regex=_,this.wordSeparators=b,this.simpleSearch=N}}n.SearchData=e;class c{constructor(_,b,N){this.reverseEdits=_,this.changes=b,this.trimAutoWhitespaceLineNumbers=N}}n.ApplyEditsResult=c;function f(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}n.shouldSynchronizeModel=f}),X(J[48],Z([0,1,26,21]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(a,s){a=(0,D.toUint32)(a);const m=this.values,e=this.prefixSum,c=s.length;return c===0?!1:(this.values=new Uint32Array(m.length+c),this.values.set(m.subarray(0,a),0),this.values.set(m.subarray(a),a+c),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,D.toUint32)(a),s=(0,D.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,D.toUint32)(a),s=(0,D.toUint32)(s);const m=this.values,e=this.prefixSum;if(a>=m.length)return!1;const c=m.length-a;return s>=c&&(s=c),s===0?!1:(this.values=new Uint32Array(m.length-s),this.values.set(m.subarray(0,a),0),this.values.set(m.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,D.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let m=s;m<=a;m++)this.prefixSum[m]=this.prefixSum[m-1]+this.values[m];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,m=this.values.length-1,e=0,c=0,f=0;for(;s<=m;)if(e=s+(m-s)/2|0,c=this.prefixSum[e],f=c-this.values[e],a<f)m=e-1;else if(a>=c)s=e+1;else break;return new d(e,a-f)}}n.PrefixSumComputer=i;class l{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],m=s>0?this._prefixSum[s-1]:0;return new d(s,a-m)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,M.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const m=this._values[a],e=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=e+m;for(let c=0;c<m;c++)this._indexBySum[e+c]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=l;class d{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}n.PrefixSumIndexOfResult=d}),X(J[49],Z([0,1,5,3,48]),function(O,n,M,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class l{constructor(w,a,s,m){this._uri=w,this._lines=a,this._eol=s,this._versionId=m,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(w){w.eol&&w.eol!==this._eol&&(this._eol=w.eol,this._lineStarts=null);const a=w.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new D.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=w.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const w=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let m=0;m<a;m++)s[m]=this._lines[m].length+w;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(w,a){this._lines[w]=a,this._lineStarts&&this._lineStarts.setValue(w,this._lines[w].length+this._eol.length)}_acceptDeleteRange(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.startLineNumber-1].substring(w.endColumn-1));return}this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.endLineNumber-1].substring(w.endColumn-1)),this._lines.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}_acceptInsertText(w,a){if(a.length===0)return;const s=(0,M.splitLines)(a);if(s.length===1){this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+s[0]+this._lines[w.lineNumber-1].substring(w.column-1));return}s[s.length-1]+=this._lines[w.lineNumber-1].substring(w.column-1),this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+s[0]);const m=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(w.lineNumber+e-1,0,s[e]),m[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(w.lineNumber,m)}}n.MirrorTextModel=l}),X(J[50],Z([0,1,5,36,3,2,47]),function(O,n,M,D,i,l,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const w=999;class a{constructor(p,A,S,h){this.searchString=p,this.isRegex=A,this.matchCase=S,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=s(this.searchString):p=this.searchString.indexOf(`
`)>=0;let A=null;try{A=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!A)return null;let S=!this.isRegex&&!p;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new d.SearchData(A,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=a;function s(N){if(!N||N.length===0)return!1;for(let p=0,A=N.length;p<A;p++){const S=N.charCodeAt(p);if(S===10)return!0;if(S===92){if(p++,p>=A)break;const h=N.charCodeAt(p);if(h===110||h===114||h===87)return!0}}return!1}n.isMultilineRegexSource=s;function m(N,p,A){if(!A)return new d.FindMatch(N,null);const S=[];for(let h=0,r=p.length;h<r;h++)S[h]=p[h];return new d.FindMatch(N,S)}n.createFindMatch=m;class e{constructor(p){const A=[];let S=0;for(let h=0,r=p.length;h<r;h++)p.charCodeAt(h)===10&&(A[S++]=h);this._lineFeedsOffsets=A}findLineFeedCountBeforeOffset(p){const A=this._lineFeedsOffsets;let S=0,h=A.length-1;if(h===-1||p<=A[0])return 0;for(;S<h;){const r=S+((h-S)/2>>0);A[r]>=p?h=r-1:A[r+1]>=p?(S=r,h=r):S=r+1}return S+1}}class c{static findMatches(p,A,S,h,r){const o=A.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(p,S,new b(o.wordSeparators,o.regex),h,r):this._doFindMatchesLineByLine(p,S,o,h,r):[]}static _getMultilineMatchRange(p,A,S,h,r,o){let u,L=0;h?(L=h.findLineFeedCountBeforeOffset(r),u=A+r+L):u=A+r;let C;if(h){const R=h.findLineFeedCountBeforeOffset(r+o.length)-L;C=u+o.length+R}else C=u+o.length;const v=p.getPositionAt(u),E=p.getPositionAt(C);return new l.Range(v.lineNumber,v.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(p,A,S,h,r){const o=p.getOffsetAt(A.getStartPosition()),u=p.getValueInRange(A,1),L=p.getEOL()===`\r
`?new e(u):null,C=[];let v=0,E;for(S.reset(0);E=S.next(u);)if(C[v++]=m(this._getMultilineMatchRange(p,o,u,L,E.index,E[0]),E,h),v>=r)return C;return C}static _doFindMatchesLineByLine(p,A,S,h,r){const o=[];let u=0;if(A.startLineNumber===A.endLineNumber){const C=p.getLineContent(A.startLineNumber).substring(A.startColumn-1,A.endColumn-1);return u=this._findMatchesInLine(S,C,A.startLineNumber,A.startColumn-1,u,o,h,r),o}const L=p.getLineContent(A.startLineNumber).substring(A.startColumn-1);u=this._findMatchesInLine(S,L,A.startLineNumber,A.startColumn-1,u,o,h,r);for(let C=A.startLineNumber+1;C<A.endLineNumber&&u<r;C++)u=this._findMatchesInLine(S,p.getLineContent(C),C,0,u,o,h,r);if(u<r){const C=p.getLineContent(A.endLineNumber).substring(0,A.endColumn-1);u=this._findMatchesInLine(S,C,A.endLineNumber,0,u,o,h,r)}return o}static _findMatchesInLine(p,A,S,h,r,o,u,L){const C=p.wordSeparators;if(!u&&p.simpleSearch){const y=p.simpleSearch,R=y.length,F=A.length;let T=-R;for(;(T=A.indexOf(y,T+R))!==-1;)if((!C||_(C,A,F,T,R))&&(o[r++]=new d.FindMatch(new l.Range(S,T+1+h,S,T+1+R+h),null),r>=L))return r;return r}const v=new b(p.wordSeparators,p.regex);let E;v.reset(0);do if(E=v.next(A),E&&(o[r++]=m(new l.Range(S,E.index+1+h,S,E.index+1+E[0].length+h),E,u),r>=L))return r;while(E);return r}static findNextMatch(p,A,S,h){const r=A.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(p,S,o,h):this._doFindNextMatchLineByLine(p,S,o,h)}static _doFindNextMatchMultiline(p,A,S,h){const r=new i.Position(A.lineNumber,1),o=p.getOffsetAt(r),u=p.getLineCount(),L=p.getValueInRange(new l.Range(r.lineNumber,r.column,u,p.getLineMaxColumn(u)),1),C=p.getEOL()===`\r
`?new e(L):null;S.reset(A.column-1);const v=S.next(L);return v?m(this._getMultilineMatchRange(p,o,L,C,v.index,v[0]),v,h):A.lineNumber!==1||A.column!==1?this._doFindNextMatchMultiline(p,new i.Position(1,1),S,h):null}static _doFindNextMatchLineByLine(p,A,S,h){const r=p.getLineCount(),o=A.lineNumber,u=p.getLineContent(o),L=this._findFirstMatchInLine(S,u,o,A.column,h);if(L)return L;for(let C=1;C<=r;C++){const v=(o+C-1)%r,E=p.getLineContent(v+1),y=this._findFirstMatchInLine(S,E,v+1,1,h);if(y)return y}return null}static _findFirstMatchInLine(p,A,S,h,r){p.reset(h-1);const o=p.next(A);return o?m(new l.Range(S,o.index+1,S,o.index+1+o[0].length),o,r):null}static findPreviousMatch(p,A,S,h){const r=A.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(p,S,o,h):this._doFindPreviousMatchLineByLine(p,S,o,h)}static _doFindPreviousMatchMultiline(p,A,S,h){const r=this._doFindMatchesMultiline(p,new l.Range(1,1,A.lineNumber,A.column),S,h,10*w);if(r.length>0)return r[r.length-1];const o=p.getLineCount();return A.lineNumber!==o||A.column!==p.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(p,new i.Position(o,p.getLineMaxColumn(o)),S,h):null}static _doFindPreviousMatchLineByLine(p,A,S,h){const r=p.getLineCount(),o=A.lineNumber,u=p.getLineContent(o).substring(0,A.column-1),L=this._findLastMatchInLine(S,u,o,h);if(L)return L;for(let C=1;C<=r;C++){const v=(r+o-C-1)%r,E=p.getLineContent(v+1),y=this._findLastMatchInLine(S,E,v+1,h);if(y)return y}return null}static _findLastMatchInLine(p,A,S,h){let r=null,o;for(p.reset(0);o=p.next(A);)r=m(new l.Range(S,o.index+1,S,o.index+1+o[0].length),o,h);return r}}n.TextModelSearch=c;function f(N,p,A,S,h){if(S===0)return!0;const r=p.charCodeAt(S-1);if(N.get(r)!==0||r===13||r===10)return!0;if(h>0){const o=p.charCodeAt(S);if(N.get(o)!==0)return!0}return!1}function g(N,p,A,S,h){if(S+h===A)return!0;const r=p.charCodeAt(S+h);if(N.get(r)!==0||r===13||r===10)return!0;if(h>0){const o=p.charCodeAt(S+h-1);if(N.get(o)!==0)return!0}return!1}function _(N,p,A,S,h){return f(N,p,A,S,h)&&g(N,p,A,S,h)}n.isValidMatch=_;class b{constructor(p,A){this._wordSeparators=p,this._searchRegex=A,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const A=p.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===A||(S=this._searchRegex.exec(p),!S))return null;const h=S.index,r=S[0].length;if(h===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){M.getNextCodePoint(p,A,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=h,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,p,A,h,r))return S}while(S);return null}}n.Searcher=b}),X(J[51],Z([0,1,2,50,5,9,23]),function(O,n,M,D,i,l,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class w{static computeUnicodeHighlights(c,f,g){const _=g?g.startLineNumber:1,b=g?g.endLineNumber:c.getLineCount(),N=new s(f),p=N.getCandidateCodePoints();let A;p==="allNonBasicAscii"?A=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):A=new RegExp(`${a(Array.from(p))}`,"g");const S=new D.Searcher(null,A),h=[];let r=!1,o,u=0,L=0,C=0;e:for(let v=_,E=b;v<=E;v++){const y=c.getLineContent(v),R=y.length;S.reset(0);do if(o=S.next(y),o){let F=o.index,T=o.index+o[0].length;if(F>0){const H=y.charCodeAt(F-1);i.isHighSurrogate(H)&&F--}if(T+1<R){const H=y.charCodeAt(T-1);i.isHighSurrogate(H)&&T++}const P=y.substring(F,T);let U=(0,d.getWordAtText)(F+1,d.DEFAULT_WORD_REGEXP,y,0);U&&U.endColumn<=F+1&&(U=null);const W=N.shouldHighlightNonBasicASCII(P,U?U.word:null);if(W!==0){W===3?u++:W===2?L++:W===1?C++:(0,l.assertNever)(W);const H=1e3;if(h.length>=H){r=!0;break e}h.push(new M.Range(v,F+1,v,T+1))}}while(o)}return{ranges:h,hasMore:r,ambiguousCharacterCount:u,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:C}}static computeUnicodeHighlightReason(c,f){const g=new s(f);switch(g.shouldHighlightNonBasicASCII(c,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=c.codePointAt(0),N=g.ambiguousCharacters.getPrimaryConfusable(b),p=i.AmbiguousCharacters.getLocales().filter(A=>!i.AmbiguousCharacters.getInstance(new Set([...f.allowedLocales,A])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=w;function a(e,c){return`[${i.escapeRegExpCharacters(e.map(g=>String.fromCodePoint(g)).join(""))}]`}class s{constructor(c){this.options=c,this.allowedCodePoints=new Set(c.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(c.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const c=new Set;if(this.options.invisibleCharacters)for(const f of i.InvisibleCharacters.codePoints)m(String.fromCodePoint(f))||c.add(f);if(this.options.ambiguousCharacters)for(const f of this.ambiguousCharacters.getConfusableCodePoints())c.add(f);for(const f of this.allowedCodePoints)c.delete(f);return c}shouldHighlightNonBasicASCII(c,f){const g=c.codePointAt(0);if(this.allowedCodePoints.has(g))return 0;if(this.options.nonBasicASCII)return 1;let _=!1,b=!1;if(f)for(const N of f){const p=N.codePointAt(0),A=i.isBasicASCII(N);_=_||A,!A&&!this.ambiguousCharacters.isAmbiguous(p)&&!i.InvisibleCharacters.isInvisibleCharacter(p)&&(b=!0)}return!_&&b?0:this.options.invisibleCharacters&&!m(c)&&i.InvisibleCharacters.isInvisibleCharacter(g)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(g)?3:0}}function m(e){return e===" "||e===`
`||e==="	"}}),X(J[52],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var M;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(M||(n.AccessibilitySupport=M={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D||(n.CodeActionTriggerType=D={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var l;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(l||(n.CompletionItemKind=l={}));var d;(function(t){t[t.Deprecated=1]="Deprecated"})(d||(n.CompletionItemTag=d={}));var w;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(n.CompletionTriggerKind=w={}));var a;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(a||(n.ContentWidgetPositionPreference=a={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var m;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(m||(n.DefaultEndOfLine=m={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var c;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(c||(n.EditorAutoIndentStrategy=c={}));var f;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=8]="autoClosingDelete",t[t.autoClosingOvertype=9]="autoClosingOvertype",t[t.autoClosingQuotes=10]="autoClosingQuotes",t[t.autoIndent=11]="autoIndent",t[t.automaticLayout=12]="automaticLayout",t[t.autoSurround=13]="autoSurround",t[t.bracketPairColorization=14]="bracketPairColorization",t[t.guides=15]="guides",t[t.codeLens=16]="codeLens",t[t.codeLensFontFamily=17]="codeLensFontFamily",t[t.codeLensFontSize=18]="codeLensFontSize",t[t.colorDecorators=19]="colorDecorators",t[t.colorDecoratorsLimit=20]="colorDecoratorsLimit",t[t.columnSelection=21]="columnSelection",t[t.comments=22]="comments",t[t.contextmenu=23]="contextmenu",t[t.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",t[t.cursorBlinking=25]="cursorBlinking",t[t.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",t[t.cursorStyle=27]="cursorStyle",t[t.cursorSurroundingLines=28]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",t[t.cursorWidth=30]="cursorWidth",t[t.disableLayerHinting=31]="disableLayerHinting",t[t.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",t[t.domReadOnly=33]="domReadOnly",t[t.dragAndDrop=34]="dragAndDrop",t[t.dropIntoEditor=35]="dropIntoEditor",t[t.emptySelectionClipboard=36]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",t[t.extraEditorClassName=38]="extraEditorClassName",t[t.fastScrollSensitivity=39]="fastScrollSensitivity",t[t.find=40]="find",t[t.fixedOverflowWidgets=41]="fixedOverflowWidgets",t[t.folding=42]="folding",t[t.foldingStrategy=43]="foldingStrategy",t[t.foldingHighlight=44]="foldingHighlight",t[t.foldingImportsByDefault=45]="foldingImportsByDefault",t[t.foldingMaximumRegions=46]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=48]="fontFamily",t[t.fontInfo=49]="fontInfo",t[t.fontLigatures=50]="fontLigatures",t[t.fontSize=51]="fontSize",t[t.fontWeight=52]="fontWeight",t[t.fontVariations=53]="fontVariations",t[t.formatOnPaste=54]="formatOnPaste",t[t.formatOnType=55]="formatOnType",t[t.glyphMargin=56]="glyphMargin",t[t.gotoLocation=57]="gotoLocation",t[t.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",t[t.hover=59]="hover",t[t.inDiffEditor=60]="inDiffEditor",t[t.inlineSuggest=61]="inlineSuggest",t[t.letterSpacing=62]="letterSpacing",t[t.lightbulb=63]="lightbulb",t[t.lineDecorationsWidth=64]="lineDecorationsWidth",t[t.lineHeight=65]="lineHeight",t[t.lineNumbers=66]="lineNumbers",t[t.lineNumbersMinChars=67]="lineNumbersMinChars",t[t.linkedEditing=68]="linkedEditing",t[t.links=69]="links",t[t.matchBrackets=70]="matchBrackets",t[t.minimap=71]="minimap",t[t.mouseStyle=72]="mouseStyle",t[t.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=74]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",t[t.multiCursorModifier=76]="multiCursorModifier",t[t.multiCursorPaste=77]="multiCursorPaste",t[t.multiCursorLimit=78]="multiCursorLimit",t[t.occurrencesHighlight=79]="occurrencesHighlight",t[t.overviewRulerBorder=80]="overviewRulerBorder",t[t.overviewRulerLanes=81]="overviewRulerLanes",t[t.padding=82]="padding",t[t.pasteAs=83]="pasteAs",t[t.parameterHints=84]="parameterHints",t[t.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",t[t.quickSuggestions=87]="quickSuggestions",t[t.quickSuggestionsDelay=88]="quickSuggestionsDelay",t[t.readOnly=89]="readOnly",t[t.readOnlyMessage=90]="readOnlyMessage",t[t.renameOnType=91]="renameOnType",t[t.renderControlCharacters=92]="renderControlCharacters",t[t.renderFinalNewline=93]="renderFinalNewline",t[t.renderLineHighlight=94]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=96]="renderValidationDecorations",t[t.renderWhitespace=97]="renderWhitespace",t[t.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",t[t.roundedSelection=99]="roundedSelection",t[t.rulers=100]="rulers",t[t.scrollbar=101]="scrollbar",t[t.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=103]="scrollBeyondLastLine",t[t.scrollPredominantAxis=104]="scrollPredominantAxis",t[t.selectionClipboard=105]="selectionClipboard",t[t.selectionHighlight=106]="selectionHighlight",t[t.selectOnLineNumbers=107]="selectOnLineNumbers",t[t.showFoldingControls=108]="showFoldingControls",t[t.showUnused=109]="showUnused",t[t.snippetSuggestions=110]="snippetSuggestions",t[t.smartSelect=111]="smartSelect",t[t.smoothScrolling=112]="smoothScrolling",t[t.stickyScroll=113]="stickyScroll",t[t.stickyTabStops=114]="stickyTabStops",t[t.stopRenderingLineAfter=115]="stopRenderingLineAfter",t[t.suggest=116]="suggest",t[t.suggestFontSize=117]="suggestFontSize",t[t.suggestLineHeight=118]="suggestLineHeight",t[t.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",t[t.suggestSelection=120]="suggestSelection",t[t.tabCompletion=121]="tabCompletion",t[t.tabIndex=122]="tabIndex",t[t.unicodeHighlighting=123]="unicodeHighlighting",t[t.unusualLineTerminators=124]="unusualLineTerminators",t[t.useShadowDOM=125]="useShadowDOM",t[t.useTabStops=126]="useTabStops",t[t.wordBreak=127]="wordBreak",t[t.wordSeparators=128]="wordSeparators",t[t.wordWrap=129]="wordWrap",t[t.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=132]="wordWrapColumn",t[t.wordWrapOverride1=133]="wordWrapOverride1",t[t.wordWrapOverride2=134]="wordWrapOverride2",t[t.wrappingIndent=135]="wrappingIndent",t[t.wrappingStrategy=136]="wrappingStrategy",t[t.showDeprecated=137]="showDeprecated",t[t.inlayHints=138]="inlayHints",t[t.editorClassName=139]="editorClassName",t[t.pixelRatio=140]="pixelRatio",t[t.tabFocusMode=141]="tabFocusMode",t[t.layoutInfo=142]="layoutInfo",t[t.wrappingInfo=143]="wrappingInfo",t[t.defaultColorDecorators=144]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(f||(n.EditorOption=f={}));var g;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(g||(n.EndOfLinePreference=g={}));var _;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(_||(n.EndOfLineSequence=_={}));var b;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(b||(n.GlyphMarginLane=b={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N||(n.IndentAction=N={}));var p;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(p||(n.InjectedTextCursorStops=p={}));var A;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(A||(n.InlayHintKind=A={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var h;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(h||(n.KeyCode=h={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var o;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(o||(n.MarkerTag=o={}));var u;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(u||(n.MinimapPosition=u={}));var L;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(L||(n.MouseTargetType=L={}));var C;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(C||(n.OverlayWidgetPositionPreference=C={}));var v;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(v||(n.OverviewRulerLane=v={}));var E;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(E||(n.PositionAffinity=E={}));var y;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(y||(n.RenderLineNumbersType=y={}));var R;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(R||(n.RenderMinimap=R={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var T;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(T||(n.ScrollbarVisibility=T={}));var P;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(P||(n.SelectionDirection=P={}));var U;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(U||(n.SignatureHelpTriggerKind=U={}));var W;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(W||(n.SymbolKind=W={}));var H;(function(t){t[t.Deprecated=1]="Deprecated"})(H||(n.SymbolTag=H={}));var I;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(I||(n.TextEditorCursorBlinkingStyle=I={}));var x;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(x||(n.TextEditorCursorStyle=x={}));var q;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(q||(n.TrackedRangeStickiness=q={}));var z;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(z||(n.WrappingIndent=z={}))}),X(J[53],Z([0,1,7,10]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(w){this._onDidChange.fire({changedLanguages:w,changedColorMap:!1})}register(w,a){return this._tokenizationSupports.set(w,a),this.handleChange([w]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(w)===a&&(this._tokenizationSupports.delete(w),this.handleChange([w]))})}get(w){return this._tokenizationSupports.get(w)||null}registerFactory(w,a){var s;(s=this._factories.get(w))===null||s===void 0||s.dispose();const m=new l(this,w,a);return this._factories.set(w,m),(0,D.toDisposable)(()=>{const e=this._factories.get(w);!e||e!==m||(this._factories.delete(w),e.dispose())})}getOrCreate(w){return ge(this,void 0,void 0,function*(){const a=this.get(w);if(a)return a;const s=this._factories.get(w);return!s||s.isResolved?null:(yield s.resolve(),this.get(w))})}isResolved(w){if(this.get(w))return!0;const s=this._factories.get(w);return!!(!s||s.isResolved)}setColorMap(w){this._colorMap=w,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class l extends D.Disposable{get isResolved(){return this._isResolved}constructor(w,a,s){super(),this._registry=w,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return ge(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return ge(this,void 0,void 0,function*(){const w=yield this._factory.tokenizationSupport;this._isResolved=!0,w&&!this._isDisposed&&this._register(this._registry.register(this._languageId,w))})}}}),X(J[54],Z([25,59]),function(O,n){return O.create("vs/base/common/platform",n)}),X(J[13],Z([0,1,54]),function(O,n,M){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,l=!1,d=!1,w=!1,a=!1,s=!1,m=!1,e=!1,c=!1,f=!1,g,_=n.LANGUAGE_DEFAULT,b=n.LANGUAGE_DEFAULT,N,p;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let A;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?A=n.globals.vscode.process:typeof process<"u"&&(A=process);const S=typeof((D=A?.versions)===null||D===void 0?void 0:D.electron)=="string",h=S&&A?.type==="renderer";if(typeof navigator=="object"&&!h)p=navigator.userAgent,i=p.indexOf("Windows")>=0,l=p.indexOf("Macintosh")>=0,e=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,d=p.indexOf("Linux")>=0,f=p?.indexOf("Mobi")>=0,s=!0,g=M.getConfiguredDefaultLocale(M.localize(0,null))||n.LANGUAGE_DEFAULT,_=g,b=navigator.language;else if(typeof A=="object"){i=A.platform==="win32",l=A.platform==="darwin",d=A.platform==="linux",w=d&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,m=S,c=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=n.LANGUAGE_DEFAULT,_=n.LANGUAGE_DEFAULT;const C=A.env.VSCODE_NLS_CONFIG;if(C)try{const v=JSON.parse(C),E=v.availableLanguages["*"];g=v.locale,b=v.osLocale,_=E||n.LANGUAGE_DEFAULT,N=v._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");let r=0;l?r=1:i?r=3:d&&(r=2),n.isWindows=i,n.isMacintosh=l,n.isLinux=d,n.isNative=a,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=f,n.userAgent=p,n.language=_,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const C=[];n.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let y=0,R=C.length;y<R;y++){const F=C[y];if(F.id===E.data.vscodeScheduleAsyncWork){C.splice(y,1),F.callback();return}}});let v=0;return E=>{const y=++v;C.push({id:y,callback:E}),n.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return C=>setTimeout(C)})(),n.OS=l||e?2:i?1:3;let o=!0,u=!1;function L(){if(!u){u=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,o=new Uint16Array(C.buffer)[0]===(2<<8)+1}return o}n.isLittleEndian=L,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),X(J[55],Z([0,1,13]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof M.globals.vscode<"u"&&typeof M.globals.vscode.process<"u"){const i=M.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),X(J[56],Z([0,1,55]),function(O,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,l=90,d=122,w=46,a=47,s=92,m=58,e=63;class c extends Error{constructor(o,u,L){let C;typeof u=="string"&&u.indexOf("not ")===0?(C="must not be",u=u.replace(/^not /,"")):C="must be";const v=o.indexOf(".")!==-1?"property":"argument";let E=`The "${o}" ${v} ${C} of type ${u}`;E+=`. Received type ${typeof L}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function f(r,o){if(r===null||typeof r!="object")throw new c(o,"Object",r)}function g(r,o){if(typeof r!="string")throw new c(o,"string",r)}const _=M.platform==="win32";function b(r){return r===a||r===s}function N(r){return r===a}function p(r){return r>=D&&r<=l||r>=i&&r<=d}function A(r,o,u,L){let C="",v=0,E=-1,y=0,R=0;for(let F=0;F<=r.length;++F){if(F<r.length)R=r.charCodeAt(F);else{if(L(R))break;R=a}if(L(R)){if(!(E===F-1||y===1))if(y===2){if(C.length<2||v!==2||C.charCodeAt(C.length-1)!==w||C.charCodeAt(C.length-2)!==w){if(C.length>2){const T=C.lastIndexOf(u);T===-1?(C="",v=0):(C=C.slice(0,T),v=C.length-1-C.lastIndexOf(u)),E=F,y=0;continue}else if(C.length!==0){C="",v=0,E=F,y=0;continue}}o&&(C+=C.length>0?`${u}..`:"..",v=2)}else C.length>0?C+=`${u}${r.slice(E+1,F)}`:C=r.slice(E+1,F),v=F-E-1;E=F,y=0}else R===w&&y!==-1?++y:y=-1}return C}function S(r,o){f(o,"pathObject");const u=o.dir||o.root,L=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${L}`:`${u}${r}${L}`:L}n.win32={resolve(...r){let o="",u="",L=!1;for(let C=r.length-1;C>=-1;C--){let v;if(C>=0){if(v=r[C],g(v,"path"),v.length===0)continue}else o.length===0?v=M.cwd():(v=M.env[`=${o}`]||M.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==o.toLowerCase()&&v.charCodeAt(2)===s)&&(v=`${o}\\`));const E=v.length;let y=0,R="",F=!1;const T=v.charCodeAt(0);if(E===1)b(T)&&(y=1,F=!0);else if(b(T))if(F=!0,b(v.charCodeAt(1))){let P=2,U=P;for(;P<E&&!b(v.charCodeAt(P));)P++;if(P<E&&P!==U){const W=v.slice(U,P);for(U=P;P<E&&b(v.charCodeAt(P));)P++;if(P<E&&P!==U){for(U=P;P<E&&!b(v.charCodeAt(P));)P++;(P===E||P!==U)&&(R=`\\\\${W}\\${v.slice(U,P)}`,y=P)}}}else y=1;else p(T)&&v.charCodeAt(1)===m&&(R=v.slice(0,2),y=2,E>2&&b(v.charCodeAt(2))&&(F=!0,y=3));if(R.length>0)if(o.length>0){if(R.toLowerCase()!==o.toLowerCase())continue}else o=R;if(L){if(o.length>0)break}else if(u=`${v.slice(y)}\\${u}`,L=F,F&&o.length>0)break}return u=A(u,!L,"\\",b),L?`${o}\\${u}`:`${o}${u}`||"."},normalize(r){g(r,"path");const o=r.length;if(o===0)return".";let u=0,L,C=!1;const v=r.charCodeAt(0);if(o===1)return N(v)?"\\":r;if(b(v))if(C=!0,b(r.charCodeAt(1))){let y=2,R=y;for(;y<o&&!b(r.charCodeAt(y));)y++;if(y<o&&y!==R){const F=r.slice(R,y);for(R=y;y<o&&b(r.charCodeAt(y));)y++;if(y<o&&y!==R){for(R=y;y<o&&!b(r.charCodeAt(y));)y++;if(y===o)return`\\\\${F}\\${r.slice(R)}\\`;y!==R&&(L=`\\\\${F}\\${r.slice(R,y)}`,u=y)}}}else u=1;else p(v)&&r.charCodeAt(1)===m&&(L=r.slice(0,2),u=2,o>2&&b(r.charCodeAt(2))&&(C=!0,u=3));let E=u<o?A(r.slice(u),!C,"\\",b):"";return E.length===0&&!C&&(E="."),E.length>0&&b(r.charCodeAt(o-1))&&(E+="\\"),L===void 0?C?`\\${E}`:E:C?`${L}\\${E}`:`${L}${E}`},isAbsolute(r){g(r,"path");const o=r.length;if(o===0)return!1;const u=r.charCodeAt(0);return b(u)||o>2&&p(u)&&r.charCodeAt(1)===m&&b(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let o,u;for(let v=0;v<r.length;++v){const E=r[v];g(E,"path"),E.length>0&&(o===void 0?o=u=E:o+=`\\${E}`)}if(o===void 0)return".";let L=!0,C=0;if(typeof u=="string"&&b(u.charCodeAt(0))){++C;const v=u.length;v>1&&b(u.charCodeAt(1))&&(++C,v>2&&(b(u.charCodeAt(2))?++C:L=!1))}if(L){for(;C<o.length&&b(o.charCodeAt(C));)C++;C>=2&&(o=`\\${o.slice(C)}`)}return n.win32.normalize(o)},relative(r,o){if(g(r,"from"),g(o,"to"),r===o)return"";const u=n.win32.resolve(r),L=n.win32.resolve(o);if(u===L||(r=u.toLowerCase(),o=L.toLowerCase(),r===o))return"";let C=0;for(;C<r.length&&r.charCodeAt(C)===s;)C++;let v=r.length;for(;v-1>C&&r.charCodeAt(v-1)===s;)v--;const E=v-C;let y=0;for(;y<o.length&&o.charCodeAt(y)===s;)y++;let R=o.length;for(;R-1>y&&o.charCodeAt(R-1)===s;)R--;const F=R-y,T=E<F?E:F;let P=-1,U=0;for(;U<T;U++){const H=r.charCodeAt(C+U);if(H!==o.charCodeAt(y+U))break;H===s&&(P=U)}if(U!==T){if(P===-1)return L}else{if(F>T){if(o.charCodeAt(y+U)===s)return L.slice(y+U+1);if(U===2)return L.slice(y+U)}E>T&&(r.charCodeAt(C+U)===s?P=U:U===2&&(P=3)),P===-1&&(P=0)}let W="";for(U=C+P+1;U<=v;++U)(U===v||r.charCodeAt(U)===s)&&(W+=W.length===0?"..":"\\..");return y+=P,W.length>0?`${W}${L.slice(y,R)}`:(L.charCodeAt(y)===s&&++y,L.slice(y,R))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const o=n.win32.resolve(r);if(o.length<=2)return r;if(o.charCodeAt(0)===s){if(o.charCodeAt(1)===s){const u=o.charCodeAt(2);if(u!==e&&u!==w)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===s)return`\\\\?\\${o}`;return r},dirname(r){g(r,"path");const o=r.length;if(o===0)return".";let u=-1,L=0;const C=r.charCodeAt(0);if(o===1)return b(C)?r:".";if(b(C)){if(u=L=1,b(r.charCodeAt(1))){let y=2,R=y;for(;y<o&&!b(r.charCodeAt(y));)y++;if(y<o&&y!==R){for(R=y;y<o&&b(r.charCodeAt(y));)y++;if(y<o&&y!==R){for(R=y;y<o&&!b(r.charCodeAt(y));)y++;if(y===o)return r;y!==R&&(u=L=y+1)}}}}else p(C)&&r.charCodeAt(1)===m&&(u=o>2&&b(r.charCodeAt(2))?3:2,L=u);let v=-1,E=!0;for(let y=o-1;y>=L;--y)if(b(r.charCodeAt(y))){if(!E){v=y;break}}else E=!1;if(v===-1){if(u===-1)return".";v=u}return r.slice(0,v)},basename(r,o){o!==void 0&&g(o,"ext"),g(r,"path");let u=0,L=-1,C=!0,v;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===m&&(u=2),o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let E=o.length-1,y=-1;for(v=r.length-1;v>=u;--v){const R=r.charCodeAt(v);if(b(R)){if(!C){u=v+1;break}}else y===-1&&(C=!1,y=v+1),E>=0&&(R===o.charCodeAt(E)?--E===-1&&(L=v):(E=-1,L=y))}return u===L?L=y:L===-1&&(L=r.length),r.slice(u,L)}for(v=r.length-1;v>=u;--v)if(b(r.charCodeAt(v))){if(!C){u=v+1;break}}else L===-1&&(C=!1,L=v+1);return L===-1?"":r.slice(u,L)},extname(r){g(r,"path");let o=0,u=-1,L=0,C=-1,v=!0,E=0;r.length>=2&&r.charCodeAt(1)===m&&p(r.charCodeAt(0))&&(o=L=2);for(let y=r.length-1;y>=o;--y){const R=r.charCodeAt(y);if(b(R)){if(!v){L=y+1;break}continue}C===-1&&(v=!1,C=y+1),R===w?u===-1?u=y:E!==1&&(E=1):u!==-1&&(E=-1)}return u===-1||C===-1||E===0||E===1&&u===C-1&&u===L+1?"":r.slice(u,C)},format:S.bind(null,"\\"),parse(r){g(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const u=r.length;let L=0,C=r.charCodeAt(0);if(u===1)return b(C)?(o.root=o.dir=r,o):(o.base=o.name=r,o);if(b(C)){if(L=1,b(r.charCodeAt(1))){let P=2,U=P;for(;P<u&&!b(r.charCodeAt(P));)P++;if(P<u&&P!==U){for(U=P;P<u&&b(r.charCodeAt(P));)P++;if(P<u&&P!==U){for(U=P;P<u&&!b(r.charCodeAt(P));)P++;P===u?L=P:P!==U&&(L=P+1)}}}}else if(p(C)&&r.charCodeAt(1)===m){if(u<=2)return o.root=o.dir=r,o;if(L=2,b(r.charCodeAt(2))){if(u===3)return o.root=o.dir=r,o;L=3}}L>0&&(o.root=r.slice(0,L));let v=-1,E=L,y=-1,R=!0,F=r.length-1,T=0;for(;F>=L;--F){if(C=r.charCodeAt(F),b(C)){if(!R){E=F+1;break}continue}y===-1&&(R=!1,y=F+1),C===w?v===-1?v=F:T!==1&&(T=1):v!==-1&&(T=-1)}return y!==-1&&(v===-1||T===0||T===1&&v===y-1&&v===E+1?o.base=o.name=r.slice(E,y):(o.name=r.slice(E,v),o.base=r.slice(E,y),o.ext=r.slice(v,y))),E>0&&E!==L?o.dir=r.slice(0,E-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(_){const r=/\\/g;return()=>{const o=M.cwd().replace(r,"/");return o.slice(o.indexOf("/"))}}return()=>M.cwd()})();n.posix={resolve(...r){let o="",u=!1;for(let L=r.length-1;L>=-1&&!u;L--){const C=L>=0?r[L]:h();g(C,"path"),C.length!==0&&(o=`${C}/${o}`,u=C.charCodeAt(0)===a)}return o=A(o,!u,"/",N),u?`/${o}`:o.length>0?o:"."},normalize(r){if(g(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===a,u=r.charCodeAt(r.length-1)===a;return r=A(r,!o,"/",N),r.length===0?o?"/":u?"./":".":(u&&(r+="/"),o?`/${r}`:r)},isAbsolute(r){return g(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let o;for(let u=0;u<r.length;++u){const L=r[u];g(L,"path"),L.length>0&&(o===void 0?o=L:o+=`/${L}`)}return o===void 0?".":n.posix.normalize(o)},relative(r,o){if(g(r,"from"),g(o,"to"),r===o||(r=n.posix.resolve(r),o=n.posix.resolve(o),r===o))return"";const u=1,L=r.length,C=L-u,v=1,E=o.length-v,y=C<E?C:E;let R=-1,F=0;for(;F<y;F++){const P=r.charCodeAt(u+F);if(P!==o.charCodeAt(v+F))break;P===a&&(R=F)}if(F===y)if(E>y){if(o.charCodeAt(v+F)===a)return o.slice(v+F+1);if(F===0)return o.slice(v+F)}else C>y&&(r.charCodeAt(u+F)===a?R=F:F===0&&(R=0));let T="";for(F=u+R+1;F<=L;++F)(F===L||r.charCodeAt(F)===a)&&(T+=T.length===0?"..":"/..");return`${T}${o.slice(v+R)}`},toNamespacedPath(r){return r},dirname(r){if(g(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===a;let u=-1,L=!0;for(let C=r.length-1;C>=1;--C)if(r.charCodeAt(C)===a){if(!L){u=C;break}}else L=!1;return u===-1?o?"/":".":o&&u===1?"//":r.slice(0,u)},basename(r,o){o!==void 0&&g(o,"ext"),g(r,"path");let u=0,L=-1,C=!0,v;if(o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let E=o.length-1,y=-1;for(v=r.length-1;v>=0;--v){const R=r.charCodeAt(v);if(R===a){if(!C){u=v+1;break}}else y===-1&&(C=!1,y=v+1),E>=0&&(R===o.charCodeAt(E)?--E===-1&&(L=v):(E=-1,L=y))}return u===L?L=y:L===-1&&(L=r.length),r.slice(u,L)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===a){if(!C){u=v+1;break}}else L===-1&&(C=!1,L=v+1);return L===-1?"":r.slice(u,L)},extname(r){g(r,"path");let o=-1,u=0,L=-1,C=!0,v=0;for(let E=r.length-1;E>=0;--E){const y=r.charCodeAt(E);if(y===a){if(!C){u=E+1;break}continue}L===-1&&(C=!1,L=E+1),y===w?o===-1?o=E:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||L===-1||v===0||v===1&&o===L-1&&o===u+1?"":r.slice(o,L)},format:S.bind(null,"/"),parse(r){g(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const u=r.charCodeAt(0)===a;let L;u?(o.root="/",L=1):L=0;let C=-1,v=0,E=-1,y=!0,R=r.length-1,F=0;for(;R>=L;--R){const T=r.charCodeAt(R);if(T===a){if(!y){v=R+1;break}continue}E===-1&&(y=!1,E=R+1),T===w?C===-1?C=R:F!==1&&(F=1):C!==-1&&(F=-1)}if(E!==-1){const T=v===0&&u?1:v;C===-1||F===0||F===1&&C===E-1&&C===v+1?o.base=o.name=r.slice(T,E):(o.name=r.slice(T,C),o.base=r.slice(T,E),o.ext=r.slice(C,E))}return v>0?o.dir=r.slice(0,v-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=_?n.win32.normalize:n.posix.normalize,n.resolve=_?n.win32.resolve:n.posix.resolve,n.relative=_?n.win32.relative:n.posix.relative,n.dirname=_?n.win32.dirname:n.posix.dirname,n.basename=_?n.win32.basename:n.posix.basename,n.extname=_?n.win32.extname:n.posix.extname,n.sep=_?n.win32.sep:n.posix.sep}),X(J[14],Z([0,1,56,13]),function(O,n,M,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,l=/^\//,d=/^\/\//;function w(u,L){if(!u.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!i.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!l.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(u,L){return!u&&!L?"file":u}function s(u,L){switch(u){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const m="",e="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(L){return L instanceof f?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,C,v,E,y,R=!1){typeof L=="object"?(this.scheme=L.scheme||m,this.authority=L.authority||m,this.path=L.path||m,this.query=L.query||m,this.fragment=L.fragment||m):(this.scheme=a(L,R),this.authority=C||m,this.path=s(this.scheme,v||m),this.query=E||m,this.fragment=y||m,w(this,R))}get fsPath(){return A(this,!1)}with(L){if(!L)return this;let{scheme:C,authority:v,path:E,query:y,fragment:R}=L;return C===void 0?C=this.scheme:C===null&&(C=m),v===void 0?v=this.authority:v===null&&(v=m),E===void 0?E=this.path:E===null&&(E=m),y===void 0?y=this.query:y===null&&(y=m),R===void 0?R=this.fragment:R===null&&(R=m),C===this.scheme&&v===this.authority&&E===this.path&&y===this.query&&R===this.fragment?this:new _(C,v,E,y,R)}static parse(L,C=!1){const v=c.exec(L);return v?new _(v[2]||m,o(v[4]||m),o(v[5]||m),o(v[7]||m),o(v[9]||m),C):new _(m,m,m,m,m)}static file(L){let C=m;if(D.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const v=L.indexOf(e,2);v===-1?(C=L.substring(2),L=e):(C=L.substring(2,v),L=L.substring(v)||e)}return new _("file",C,L,m,m)}static from(L,C){return new _(L.scheme,L.authority,L.path,L.query,L.fragment,C)}static joinPath(L,...C){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return D.isWindows&&L.scheme==="file"?v=f.file(M.win32.join(A(L,!0),...C)).path:v=M.posix.join(L.path,...C),L.with({path:v})}toString(L=!1){return S(this,L)}toJSON(){return this}static revive(L){var C,v;if(L){if(L instanceof f)return L;{const E=new _(L);return E._formatted=(C=L.external)!==null&&C!==void 0?C:null,E._fsPath=L._sep===g&&(v=L.fsPath)!==null&&v!==void 0?v:null,E}}else return L}}n.URI=f;const g=D.isWindows?1:void 0;class _ extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=A(this,!1)),this._fsPath}toString(L=!1){return L?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=g),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(u,L,C){let v,E=-1;for(let y=0;y<u.length;y++){const R=u.charCodeAt(y);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||L&&R===47||C&&R===91||C&&R===93||C&&R===58)E!==-1&&(v+=encodeURIComponent(u.substring(E,y)),E=-1),v!==void 0&&(v+=u.charAt(y));else{v===void 0&&(v=u.substr(0,y));const F=b[R];F!==void 0?(E!==-1&&(v+=encodeURIComponent(u.substring(E,y)),E=-1),v+=F):E===-1&&(E=y)}}return E!==-1&&(v+=encodeURIComponent(u.substring(E))),v!==void 0?v:u}function p(u){let L;for(let C=0;C<u.length;C++){const v=u.charCodeAt(C);v===35||v===63?(L===void 0&&(L=u.substr(0,C)),L+=b[v]):L!==void 0&&(L+=u[C])}return L!==void 0?L:u}function A(u,L){let C;return u.authority&&u.path.length>1&&u.scheme==="file"?C=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?L?C=u.path.substr(1):C=u.path[1].toLowerCase()+u.path.substr(2):C=u.path,D.isWindows&&(C=C.replace(/\//g,"\\")),C}n.uriToFsPath=A;function S(u,L){const C=L?p:N;let v="",{scheme:E,authority:y,path:R,query:F,fragment:T}=u;if(E&&(v+=E,v+=":"),(y||E==="file")&&(v+=e,v+=e),y){let P=y.indexOf("@");if(P!==-1){const U=y.substr(0,P);y=y.substr(P+1),P=U.lastIndexOf(":"),P===-1?v+=C(U,!1,!1):(v+=C(U.substr(0,P),!1,!1),v+=":",v+=C(U.substr(P+1),!1,!0)),v+="@"}y=y.toLowerCase(),P=y.lastIndexOf(":"),P===-1?v+=C(y,!1,!0):(v+=C(y.substr(0,P),!1,!0),v+=y.substr(P))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const P=R.charCodeAt(1);P>=65&&P<=90&&(R=`/${String.fromCharCode(P+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const P=R.charCodeAt(0);P>=65&&P<=90&&(R=`${String.fromCharCode(P+32)}:${R.substr(2)}`)}v+=C(R,!0,!1)}return F&&(v+="?",v+=C(F,!1,!1)),T&&(v+="#",v+=L?T:N(T,!1,!1)),v}function h(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+h(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(u){return u.match(r)?u.replace(r,L=>h(L)):u}}),X(J[60],Z([0,1,4,7,10,11,13,5]),function(O,n,M,D,i,l,d,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function m(o){d.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=m;class e{constructor(u,L,C,v){this.vsWorker=u,this.req=L,this.method=C,this.args=v,this.type=0}}class c{constructor(u,L,C,v){this.vsWorker=u,this.seq=L,this.res=C,this.err=v,this.type=1}}class f{constructor(u,L,C,v){this.vsWorker=u,this.req=L,this.eventName=C,this.arg=v,this.type=2}}class g{constructor(u,L,C){this.vsWorker=u,this.req=L,this.event=C,this.type=3}}class _{constructor(u,L){this.vsWorker=u,this.req=L,this.type=4}}class b{constructor(u){this._workerId=-1,this._handler=u,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(u){this._workerId=u}sendMessage(u,L){const C=String(++this._lastSentReq);return new Promise((v,E)=>{this._pendingReplies[C]={resolve:v,reject:E},this._send(new e(this._workerId,C,u,L))})}listen(u,L){let C=null;const v=new D.Emitter({onWillAddFirstListener:()=>{C=String(++this._lastSentReq),this._pendingEmitters.set(C,v),this._send(new f(this._workerId,C,u,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(C),this._send(new _(this._workerId,C)),C=null}});return v.event}handleMessage(u){!u||!u.vsWorker||this._workerId!==-1&&u.vsWorker!==this._workerId||this._handleMessage(u)}_handleMessage(u){switch(u.type){case 1:return this._handleReplyMessage(u);case 0:return this._handleRequestMessage(u);case 2:return this._handleSubscribeEventMessage(u);case 3:return this._handleEventMessage(u);case 4:return this._handleUnsubscribeEventMessage(u)}}_handleReplyMessage(u){if(!this._pendingReplies[u.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[u.seq];if(delete this._pendingReplies[u.seq],u.err){let C=u.err;u.err.$isError&&(C=new Error,C.name=u.err.name,C.message=u.err.message,C.stack=u.err.stack),L.reject(C);return}L.resolve(u.res)}_handleRequestMessage(u){const L=u.req;this._handler.handleMessage(u.method,u.args).then(v=>{this._send(new c(this._workerId,L,v,void 0))},v=>{v.detail instanceof Error&&(v.detail=(0,M.transformErrorForSerialization)(v.detail)),this._send(new c(this._workerId,L,void 0,(0,M.transformErrorForSerialization)(v)))})}_handleSubscribeEventMessage(u){const L=u.req,C=this._handler.handleEvent(u.eventName,u.arg)(v=>{this._send(new g(this._workerId,L,v))});this._pendingEvents.set(L,C)}_handleEventMessage(u){if(!this._pendingEmitters.has(u.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(u.req).fire(u.event)}_handleUnsubscribeEventMessage(u){if(!this._pendingEvents.has(u.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(u.req).dispose(),this._pendingEvents.delete(u.req)}_send(u){const L=[];if(u.type===0)for(let C=0;C<u.args.length;C++)u.args[C]instanceof ArrayBuffer&&L.push(u.args[C]);else u.type===1&&u.res instanceof ArrayBuffer&&L.push(u.res);this._handler.sendMessage(u,L)}}class N extends i.Disposable{constructor(u,L,C){super();let v=null;this._worker=this._register(u.create("vs/base/common/worker/simpleWorker",P=>{this._protocol.handleMessage(P)},P=>{v?.(P)})),this._protocol=new b({sendMessage:(P,U)=>{this._worker.postMessage(P,U)},handleMessage:(P,U)=>{if(typeof C[P]!="function")return Promise.reject(new Error("Missing method "+P+" on main thread host."));try{return Promise.resolve(C[P].apply(C,U))}catch(W){return Promise.reject(W)}},handleEvent:(P,U)=>{if(A(P)){const W=C[P].call(C,U);if(typeof W!="function")throw new Error(`Missing dynamic event ${P} on main thread host.`);return W}if(p(P)){const W=C[P];if(typeof W!="function")throw new Error(`Missing event ${P} on main thread host.`);return W}throw new Error(`Malformed event name ${P}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?E=y.getConfig():typeof globalThis.requirejs<"u"&&(E=globalThis.requirejs.s.contexts._.config);const R=(0,l.getAllMethodNames)(C);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(E)),L,R]);const F=(P,U)=>this._request(P,U),T=(P,U)=>this._protocol.listen(P,U);this._lazyProxy=new Promise((P,U)=>{v=U,this._onModuleLoaded.then(W=>{P(S(W,F,T))},W=>{U(W),this._onError("Worker failed to load "+L,W)})})}getProxyObject(){return this._lazyProxy}_request(u,L){return new Promise((C,v)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(u,L).then(C,v)},v)})}_onError(u,L){console.error(u),console.info(L)}}n.SimpleWorkerClient=N;function p(o){return o[0]==="o"&&o[1]==="n"&&w.isUpperAsciiLetter(o.charCodeAt(2))}function A(o){return/^onDynamic/.test(o)&&w.isUpperAsciiLetter(o.charCodeAt(9))}function S(o,u,L){const C=y=>function(){const R=Array.prototype.slice.call(arguments,0);return u(y,R)},v=y=>function(R){return L(y,R)},E={};for(const y of o){if(A(y)){E[y]=v(y);continue}if(p(y)){E[y]=L(y,void 0);continue}E[y]=C(y)}return E}class h{constructor(u,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new b({sendMessage:(C,v)=>{u(C,v)},handleMessage:(C,v)=>this._handleMessage(C,v),handleEvent:(C,v)=>this._handleEvent(C,v)})}onmessage(u){this._protocol.handleMessage(u)}_handleMessage(u,L){if(u===a)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this._requestHandler[u].apply(this._requestHandler,L))}catch(C){return Promise.reject(C)}}_handleEvent(u,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(A(u)){const C=this._requestHandler[u].call(this._requestHandler,L);if(typeof C!="function")throw new Error(`Missing dynamic event ${u} on request handler.`);return C}if(p(u)){const C=this._requestHandler[u];if(typeof C!="function")throw new Error(`Missing event ${u} on request handler.`);return C}throw new Error(`Malformed event name ${u}`)}initialize(u,L,C,v){this._protocol.setWorkerId(u);const R=S(v,(F,T)=>this._protocol.sendMessage(F,T),(F,T)=>this._protocol.listen(F,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve((0,l.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((F,T)=>{(globalThis.require||O)([C],U=>{if(this._requestHandler=U.create(R),!this._requestHandler){T(new Error("No RequestHandler!"));return}F((0,l.getAllMethodNames)(this._requestHandler))},T)}))}}n.SimpleWorkerServer=h;function r(o){return new h(o,null)}n.create=r}),X(J[57],Z([0,1,34,14,2,53]),function(O,n,M,D,i,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class d{constructor(r,o,u){this.offset=r,this.type=o,this.language=u,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=d;class w{constructor(r,o){this.tokens=r,this.endState=o,this._tokenizationResultBrand=void 0}}n.TokenizationResult=w;class a{constructor(r,o){this.tokens=r,this.endState=o,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var s;(function(h){const r=new Map;r.set(0,M.Codicon.symbolMethod),r.set(1,M.Codicon.symbolFunction),r.set(2,M.Codicon.symbolConstructor),r.set(3,M.Codicon.symbolField),r.set(4,M.Codicon.symbolVariable),r.set(5,M.Codicon.symbolClass),r.set(6,M.Codicon.symbolStruct),r.set(7,M.Codicon.symbolInterface),r.set(8,M.Codicon.symbolModule),r.set(9,M.Codicon.symbolProperty),r.set(10,M.Codicon.symbolEvent),r.set(11,M.Codicon.symbolOperator),r.set(12,M.Codicon.symbolUnit),r.set(13,M.Codicon.symbolValue),r.set(15,M.Codicon.symbolEnum),r.set(14,M.Codicon.symbolConstant),r.set(15,M.Codicon.symbolEnum),r.set(16,M.Codicon.symbolEnumMember),r.set(17,M.Codicon.symbolKeyword),r.set(27,M.Codicon.symbolSnippet),r.set(18,M.Codicon.symbolText),r.set(19,M.Codicon.symbolColor),r.set(20,M.Codicon.symbolFile),r.set(21,M.Codicon.symbolReference),r.set(22,M.Codicon.symbolCustomColor),r.set(23,M.Codicon.symbolFolder),r.set(24,M.Codicon.symbolTypeParameter),r.set(25,M.Codicon.account),r.set(26,M.Codicon.issues);function o(C){let v=r.get(C);return v||(console.info("No codicon found for CompletionItemKind "+C),v=M.Codicon.symbolProperty),v}h.toIcon=o;const u=new Map;u.set("method",0),u.set("function",1),u.set("constructor",2),u.set("field",3),u.set("variable",4),u.set("class",5),u.set("struct",6),u.set("interface",7),u.set("module",8),u.set("property",9),u.set("event",10),u.set("operator",11),u.set("unit",12),u.set("value",13),u.set("constant",14),u.set("enum",15),u.set("enum-member",16),u.set("enumMember",16),u.set("keyword",17),u.set("snippet",27),u.set("text",18),u.set("color",19),u.set("file",20),u.set("reference",21),u.set("customcolor",22),u.set("folder",23),u.set("type-parameter",24),u.set("typeParameter",24),u.set("account",25),u.set("issue",26);function L(C,v){let E=u.get(C);return typeof E>"u"&&!v&&(E=9),E}h.fromString=L})(s||(n.CompletionItemKinds=s={}));var m;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(m||(n.InlineCompletionTriggerKind=m={}));class e{constructor(r,o,u,L){this.range=r,this.text=o,this.completionKind=u,this.isSnippetText=L}equals(r){return i.Range.lift(this.range).equalsRange(r.range)&&this.text===r.text&&this.completionKind===r.completionKind&&this.isSnippetText===r.isSnippetText}}n.SelectedSuggestionInfo=e;var c;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(c||(n.SignatureHelpTriggerKind=c={}));var f;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(f||(n.DocumentHighlightKind=f={}));function g(h){return h&&D.URI.isUri(h.uri)&&i.Range.isIRange(h.range)&&(i.Range.isIRange(h.originSelectionRange)||i.Range.isIRange(h.targetSelectionRange))}n.isLocationLink=g;var _;(function(h){const r=new Map;r.set(0,M.Codicon.symbolFile),r.set(1,M.Codicon.symbolModule),r.set(2,M.Codicon.symbolNamespace),r.set(3,M.Codicon.symbolPackage),r.set(4,M.Codicon.symbolClass),r.set(5,M.Codicon.symbolMethod),r.set(6,M.Codicon.symbolProperty),r.set(7,M.Codicon.symbolField),r.set(8,M.Codicon.symbolConstructor),r.set(9,M.Codicon.symbolEnum),r.set(10,M.Codicon.symbolInterface),r.set(11,M.Codicon.symbolFunction),r.set(12,M.Codicon.symbolVariable),r.set(13,M.Codicon.symbolConstant),r.set(14,M.Codicon.symbolString),r.set(15,M.Codicon.symbolNumber),r.set(16,M.Codicon.symbolBoolean),r.set(17,M.Codicon.symbolArray),r.set(18,M.Codicon.symbolObject),r.set(19,M.Codicon.symbolKey),r.set(20,M.Codicon.symbolNull),r.set(21,M.Codicon.symbolEnumMember),r.set(22,M.Codicon.symbolStruct),r.set(23,M.Codicon.symbolEvent),r.set(24,M.Codicon.symbolOperator),r.set(25,M.Codicon.symbolTypeParameter);function o(u){let L=r.get(u);return L||(console.info("No codicon found for SymbolKind "+u),L=M.Codicon.symbolProperty),L}h.toIcon=o})(_||(n.SymbolKinds=_={}));class b{}n.TextEdit=b;class N{static fromValue(r){switch(r){case"comment":return N.Comment;case"imports":return N.Imports;case"region":return N.Region}return new N(r)}constructor(r){this.value=r}}n.FoldingRangeKind=N,N.Comment=new N("comment"),N.Imports=new N("imports"),N.Region=new N("region");var p;(function(h){function r(o){return!o||typeof o!="object"?!1:typeof o.id=="string"&&typeof o.title=="string"}h.is=r})(p||(n.Command=p={}));var A;(function(h){h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(A||(n.InlayHintKind=A={}));class S{constructor(r){this.createSupport=r,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(r=>{r&&r.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=S,n.TokenizationRegistry=new l.TokenizationRegistry}),X(J[58],Z([0,1,32,7,30,14,3,2,35,57,52]),function(O,n,M,D,i,l,d,w,a,s,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(g,_){return(0,i.KeyChord)(g,_)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function c(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:D.Emitter,KeyCode:m.KeyCode,KeyMod:e,Position:d.Position,Range:w.Range,Selection:a.Selection,SelectionDirection:m.SelectionDirection,MarkerSeverity:m.MarkerSeverity,MarkerTag:m.MarkerTag,Uri:l.URI,Token:s.Token}}n.createMonacoBaseAPI=c}),X(J[61],Z([0,1,19,14,3,2,49,23,45,46,58,18,51,43,11,44]),function(O,n,M,D,i,l,d,w,a,s,m,e,c,f,g,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class b extends d.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const h=[];for(let r=0;r<this._lines.length;r++){const o=this._lines[r],u=this.offsetAt(new i.Position(r+1,1)),L=o.matchAll(S);for(const C of L)(C.index||C.index===0)&&(C.index=C.index+u),h.push(C)}return h}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,h){const r=(0,w.getWordAtText)(S.column,(0,w.ensureValidWordDefinition)(h),this._lines[S.lineNumber-1],0);return r?new l.Range(S.lineNumber,r.startColumn,S.lineNumber,r.endColumn):null}words(S){const h=this._lines,r=this._wordenize.bind(this);let o=0,u="",L=0,C=[];return{*[Symbol.iterator](){for(;;)if(L<C.length){const v=u.substring(C[L].start,C[L].end);L+=1,yield v}else if(o<h.length)u=h[o],C=r(u,S),L=0,o+=1;else break}}}getLineWords(S,h){const r=this._lines[S-1],o=this._wordenize(r,h),u=[];for(const L of o)u.push({word:r.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return u}_wordenize(S,h){const r=[];let o;for(h.lastIndex=0;(o=h.exec(S))&&o[0].length!==0;)r.push({start:o.index,end:o.index+o[0].length});return r}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const h=this._eol,r=S.startLineNumber-1,o=S.endLineNumber-1,u=[];u.push(this._lines[r].substring(S.startColumn-1));for(let L=r+1;L<o;L++)u.push(this._lines[L]);return u.push(this._lines[o].substring(0,S.endColumn-1)),u.join(h)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(S),r=this._lines[h.index].length;return{lineNumber:1+h.index,column:1+Math.min(h.remainder,r)}}_validateRange(S){const h=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),r=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return h.lineNumber!==S.startLineNumber||h.column!==S.startColumn||r.lineNumber!==S.endLineNumber||r.column!==S.endColumn?{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:r.lineNumber,endColumn:r.column}:S}_validatePosition(S){if(!i.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:h,column:r}=S,o=!1;if(h<1)h=1,r=1,o=!0;else if(h>this._lines.length)h=this._lines.length,r=this._lines[h-1].length+1,o=!0;else{const u=this._lines[h-1].length+1;r<1?(r=1,o=!0):r>u&&(r=u,o=!0)}return o?{lineNumber:h,column:r}:S}}class N{constructor(S,h){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=h,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(h=>S.push(this._models[h])),S}acceptNewModel(S){this._models[S.url]=new b(D.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,h){if(!this._models[S])return;this._models[S].onEvents(h)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}computeUnicodeHighlights(S,h,r){return ge(this,void 0,void 0,function*(){const o=this._getModel(S);return o?c.UnicodeTextModelHighlighter.computeUnicodeHighlights(o,h,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(S,h,r,o){return ge(this,void 0,void 0,function*(){const u=this._getModel(S),L=this._getModel(h);return!u||!L?null:N.computeDiff(u,L,r,o)})}static computeDiff(S,h,r,o){const u=o==="advanced"?f.linesDiffComputers.getAdvanced():f.linesDiffComputers.getLegacy(),L=S.getLinesContent(),C=h.getLinesContent(),v=u.computeDiff(L,C,r),E=v.changes.length>0?!1:this._modelsAreIdentical(S,h);function y(R){return R.map(F=>{var T;return[F.originalRange.startLineNumber,F.originalRange.endLineNumberExclusive,F.modifiedRange.startLineNumber,F.modifiedRange.endLineNumberExclusive,(T=F.innerChanges)===null||T===void 0?void 0:T.map(P=>[P.originalRange.startLineNumber,P.originalRange.startColumn,P.originalRange.endLineNumber,P.originalRange.endColumn,P.modifiedRange.startLineNumber,P.modifiedRange.startColumn,P.modifiedRange.endLineNumber,P.modifiedRange.endColumn])]})}return{identical:E,quitEarly:v.hitTimeout,changes:y(v.changes),moves:v.moves.map(R=>[R.lineRangeMapping.originalRange.startLineNumber,R.lineRangeMapping.originalRange.endLineNumberExclusive,R.lineRangeMapping.modifiedRange.startLineNumber,R.lineRangeMapping.modifiedRange.endLineNumberExclusive,y(R.changes)])}}static _modelsAreIdentical(S,h){const r=S.getLineCount(),o=h.getLineCount();if(r!==o)return!1;for(let u=1;u<=r;u++){const L=S.getLineContent(u),C=h.getLineContent(u);if(L!==C)return!1}return!0}computeMoreMinimalEdits(S,h,r){return ge(this,void 0,void 0,function*(){const o=this._getModel(S);if(!o)return h;const u=[];let L;h=h.slice(0).sort((C,v)=>{if(C.range&&v.range)return l.Range.compareRangesUsingStarts(C.range,v.range);const E=C.range?0:1,y=v.range?0:1;return E-y});for(let{range:C,text:v,eol:E}of h){if(typeof E=="number"&&(L=E),l.Range.isEmpty(C)&&!v)continue;const y=o.getValueInRange(C);if(v=v.replace(/\r\n|\n|\r/g,o.eol),y===v)continue;if(Math.max(v.length,y.length)>N._diffLimit){u.push({range:C,text:v});continue}const R=(0,M.stringDiff)(y,v,r),F=o.offsetAt(l.Range.lift(C).getStartPosition());for(const T of R){const P=o.positionAt(F+T.originalStart),U=o.positionAt(F+T.originalStart+T.originalLength),W={text:v.substr(T.modifiedStart,T.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:U.lineNumber,endColumn:U.column}};o.getValueInRange(W.range)!==W.text&&u.push(W)}}return typeof L=="number"&&u.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),u})}computeLinks(S){return ge(this,void 0,void 0,function*(){const h=this._getModel(S);return h?(0,a.computeLinks)(h):null})}computeDefaultDocumentColors(S){return ge(this,void 0,void 0,function*(){const h=this._getModel(S);return h?(0,_.computeDefaultDocumentColors)(h):null})}textualSuggest(S,h,r,o){return ge(this,void 0,void 0,function*(){const u=new e.StopWatch,L=new RegExp(r,o),C=new Set;e:for(const v of S){const E=this._getModel(v);if(E){for(const y of E.words(L))if(!(y===h||!isNaN(Number(y)))&&(C.add(y),C.size>N._suggestionsLimit))break e}}return{words:Array.from(C),duration:u.elapsed()}})}computeWordRanges(S,h,r,o){return ge(this,void 0,void 0,function*(){const u=this._getModel(S);if(!u)return Object.create(null);const L=new RegExp(r,o),C=Object.create(null);for(let v=h.startLineNumber;v<h.endLineNumber;v++){const E=u.getLineWords(v,L);for(const y of E){if(!isNaN(Number(y.word)))continue;let R=C[y.word];R||(R=[],C[y.word]=R),R.push({startLineNumber:v,startColumn:y.startColumn,endLineNumber:v,endColumn:y.endColumn})}}return C})}navigateValueSet(S,h,r,o,u){return ge(this,void 0,void 0,function*(){const L=this._getModel(S);if(!L)return null;const C=new RegExp(o,u);h.startColumn===h.endColumn&&(h={startLineNumber:h.startLineNumber,startColumn:h.startColumn,endLineNumber:h.endLineNumber,endColumn:h.endColumn+1});const v=L.getValueInRange(h),E=L.getWordAtPosition({lineNumber:h.startLineNumber,column:h.startColumn},C);if(!E)return null;const y=L.getValueInRange(E);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(h,v,E,y,r)})}loadForeignModule(S,h,r){const o=(C,v)=>this._host.fhr(C,v),L={host:(0,g.createProxyObject)(r,o),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(L,h),Promise.resolve((0,g.getAllMethodNames)(this._foreignModule))):new Promise((C,v)=>{O([S],E=>{this._foreignModule=E.create(L,h),C((0,g.getAllMethodNames)(this._foreignModule))},v)})}fmr(S,h){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,h))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function p(A){return new N(A,null)}n.create=p,typeof importScripts=="function"&&(globalThis.monaco=(0,m.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map